#if !defined(AFX_CALENDARINFO_H__B135812D_107F_4E77_B08B_F0F58AF8AC98__INCLUDED_)
#define AFX_CALENDARINFO_H__B135812D_107F_4E77_B08B_F0F58AF8AC98__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CalendarInfo.h : header file
//
#include "Function.h"
#include "WhatIsThisEditNotify.h"
#include "ListCtrlEx.h"
#include "WhatIsItButton.h"
/////////////////////////////////////////////////////////////////////////////
// CCalendarInfo dialog

class CCalendarInfo : public CFunction
{
    DECLARE_DYNCREATE(CCalendarInfo)
// Construction
public:
        CCalendarInfo(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CCalendarInfo)
        enum { IDD = IDD_ENUMCALENDARINFO };
        CWhatIsItButton c_CAL_TAIWAN;
        CWhatIsItButton c_CAL_KOREA;
        CWhatIsItButton c_CAL_JAPAN;
        CWhatIsItButton c_CAL_HIJRI;
        CWhatIsItButton c_CAL_GREGORIAN_US;
        CWhatIsItButton c_CAL_GREGORIAN;
        CWhatIsItButton c_CAL_THAI;
        CWhatIsItButton c_CAL_HEBREW;
        CWhatIsItButton c_CAL_GREGORIAN_XLIT_FRENCH;
        CWhatIsItButton c_CAL_GREGORIAN_XLIT_ENGLISH;
        CWhatIsItButton c_CAL_GREGORIAN_ME_FRENCH;
        CWhatIsItButton c_CAL_GREGORIAN_ARABIC;
        CWhatIsItButton c_EnumAllCalendars;
        CWhatIsItButton c_GetCalendarInfo;
        CStatic x_CallbackName;
        CWhatIsItButton c_CALTYPE;
        CWhatIsThisEditNotify c_CAL_SYEARMONTH;
        CWhatIsThisEditNotify c_CAL_SSHORTDATE;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME9;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME8;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME7;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME6;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME5;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME4;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME3;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME2;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME13;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME12;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME11;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME10;
        CWhatIsThisEditNotify c_CAL_SMONTHNAME1;
        CWhatIsThisEditNotify c_CAL_SLONGDATE;
        CWhatIsThisEditNotify c_CAL_SERASTRING;
        CWhatIsThisEditNotify c_CAL_SDAYNAME7;
        CWhatIsThisEditNotify c_CAL_SDAYNAME6;
        CWhatIsThisEditNotify c_CAL_SDAYNAME5;
        CWhatIsThisEditNotify c_CAL_SDAYNAME4;
        CWhatIsThisEditNotify c_CAL_SDAYNAME3;
        CWhatIsThisEditNotify c_CAL_SDAYNAME2;
        CWhatIsThisEditNotify c_CAL_SDAYNAME1;
        CWhatIsThisEditNotify c_CAL_SCALENAME;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME9;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME8;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME7;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME6;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME5;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME4;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME3;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME2;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME13;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME12;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME11;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME10;
        CWhatIsThisEditNotify c_CAL_SABBREVMONTHNAME1;
        CWhatIsThisEditNotify c_CAL_SABBREVDAYNAME7;
        CWhatIsThisEditNotify c_CAL_SABBREVDAYNAME6;
        CWhatIsThisEditNotify c_CAL_SABBREVDAYNAME5;
        CWhatIsThisEditNotify c_CAL_SABBREVDAYNAME4;
        CWhatIsThisEditNotify c_CAL_SABBREVDAYNAME3;
        CWhatIsThisEditNotify c_CAL_SABBREVDAYNAME2;
        CWhatIsThisEditNotify c_CAL_SABBREVDAYNAME1;
        CWhatIsThisEditNotify c_CAL_IYEAROFFSETRANGE;
        CWhatIsThisEditNotify c_CAL_TWODIGITYEARMAX;
        CWhatIsThisEditNotify c_CAL_ICALINTVALUE;
        CWhatIsThisEdit   c_CallbackName;
        CListCtrlEx  c_Output;
        CWhatIsItButton c_EnumCalendarEx;
        CWhatIsItButton c_EnumCalendar;
        CWhatIsItButton c_SpareRadio;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CCalendarInfo)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual void OnSetActive();
        virtual BOOL IndexOK(CWnd * wnd);
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & name, UINT mode);
protected: // Methods
        CALID ControlIDtoCALID(UINT ctlid);
        static BOOL CALLBACK EnumCalendarInfoProc(LPTSTR);
        static BOOL CALLBACK EnumCalendarInfoProcEx(LPTSTR, CALID);
        static BOOL CALLBACK EnumCalendarInfoProcD(LPTSTR);
        static BOOL CALLBACK EnumCalendarInfoProcExD(LPTSTR, CALID);
        static CCalendarInfo * LogWnd;
        BOOL CanBeDWord(UINT item);
        void EnableDisplay(BOOL mode);
        void updateControls();
        BOOL IsDisplay(CWnd * wnd);
        void ShowCalendarInfo();
        void UpdateCode();
protected: // data
         UINT ItemSelection;
         UINT CalidSelection;
         UINT EnumCalid; // former CALID selection
         int CalWidth;   // calendar ID column width
protected: // Message handlers
        afx_msg LRESULT OnSelectLCType(WPARAM, LPARAM);
        afx_msg void OnCal(UINT id);
        afx_msg LRESULT OnLogData(WPARAM, LPARAM);
        // Generated message map functions
        //{{AFX_MSG(CCalendarInfo)
        virtual BOOL OnInitDialog();
        afx_msg void OnEnumCalendarInfo();
        afx_msg void OnEnumCalendarInfoEx();
        afx_msg void OnGetCalendarInfo();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnChangeCallbackName();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CALENDARINFO_H__B135812D_107F_4E77_B08B_F0F58AF8AC98__INCLUDED_)
