template <class T> class Container {
    protected:
       T p; // actual object
       long count;
    public:
       void Delete() {
           long n = ::InterlockedDecrement(&count);
           if(n == 0)
                delete this;
       }
    public:
       Container<T>() { count = 1; }
       ~Container<T>() {  } 
       operator T*() { return &p; }
       T & operator *() { return p; }
       T* operator->() { return &p; }
       Container<T> * AddRef() {
           long n = ::InterlockedIncrement(&count); 
           return this; }
};

// Usage:
//  Declare a variable of type Container<T> *
//  Assign a new Container<T> to it
//  Use AddRef to get a new pointer
//  Use Delete() to delete the pointer
