#include "stdafx.h"
#include "ConvertString.h"


/****************************************************************************
*                                ConvertString
* Inputs:
*       CString & string: String
*       UINT mode: Desired mode: 0 (no conversion), 8 (make UTF-8), 16 (UTF-16)
* Result: void
*       
* Effect: 
*       If in Unicode mode, honors the conversion request.
****************************************************************************/

void ConvertString(CString & string, UINT mode)
    {
#ifndef _UNICODE
     ASSERT(mode == 0); // should not have 8 or 16 in ASCII mode!
     return;  // no conversion in ASCII mode
#else
     if(mode == 0)
        return; // no conversion requested
     if(mode == 16)
        return; // already in Unicode format
     // If we have a conversion request, we convert the string text to
     // UTF-8, then back to Unicode. This seems weird
     LPSTR
#endif
    } // ConvertString
