#if !defined(AFX_DATEFORMATS_H__56DACA70_6C4E_413B_AD34_72E883195EC1__INCLUDED_)
#define AFX_DATEFORMATS_H__56DACA70_6C4E_413B_AD34_72E883195EC1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// DateFormats.h : header file
//
#include "CodeTemplate.h"
#include "Function.h"
#include "WhatIsThisEdit.h"
#include "WhatIsItButton.h"
#include "ListCtrlEx.h"

/////////////////////////////////////////////////////////////////////////////
// CDateFormats dialog

class CDateFormats : public CFunction
{
    DECLARE_DYNCREATE(CDateFormats)
// Construction
public:
        CDateFormats(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CDateFormats)
	enum { IDD = IDD_DATEFORMATS };
	CButton	c_IgnoreCaption;
        CWhatIsItButton c_EnumDateFormatsEx;
        CWhatIsItButton c_EnumDateFormats;
        CWhatIsItButton c_DATE_YEARMONTH;
        CWhatIsItButton c_DATE_LONGDATE;
        CWhatIsItButton c_DATE_SHORTDATE;
        CWhatIsThisEdit   c_CallbackName;
        CListCtrlEx       c_Output;
        CWhatIsItButton c_SpareRadio;
	//}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CDateFormats)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual BOOL IndexOK(CWnd * wnd);
protected: // data
        static CDateFormats * LogWnd;
        static BOOL CALLBACK EnumDateFormatsProc(LPTSTR date);
        static BOOL CALLBACK EnumDateFormatsProcEx(LPTSTR date, CALID calid);
        int DateWidth;
protected: // methods
        void ShowDateFormats();
        void UpdateCode();
        void updateControls();
protected: // message handlers
        afx_msg LRESULT OnSelectLCType(WPARAM, LPARAM);
        afx_msg LRESULT OnLogData(WPARAM, LPARAM);
        // Generated message map functions
        //{{AFX_MSG(CDateFormats)
        afx_msg void OnEnumdateformats();
        afx_msg void OnEnumdateformatsex();
        afx_msg void OnDateLongdate();
        afx_msg void OnDateShortdate();
        afx_msg void OnDateYearmonth();
        virtual BOOL OnInitDialog();
        afx_msg void OnChangeCallbackName();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DATEFORMATS_H__56DACA70_6C4E_413B_AD34_72E883195EC1__INCLUDED_)
