#include "stdafx.h"
#include "resource.h"
#include "localeexplorerdlg.h" // the only module besides localeexplorerdlg.cpp that needs this!
#include "DeferredMessage.h"


/****************************************************************************
*                               EnquueueMessage
* Inputs:
*       CWnd * wnd:
*       UINT msg:
*       WPARAM wParam: Defaults to 0
*       LPARAM lParam: Defaults to 0
* Result: void
*       
* Effect: 
*       Enqueues the request for later processing
****************************************************************************/

void EnqueueMessage(CWnd * wnd, UINT msg, WPARAM wParam /* =0 */, LPARAM lParam /* =0 */)
    {
     CLocaleExplorerDlg * dlg = (CLocaleExplorerDlg *)AfxGetMainWnd();

     dlg->EnqueueMessage(wnd, msg, wParam, lParam);
    } // EnquueueMessage
