#if !defined(AFX_ENUMLANGUAGEGROUPLOCALES_H__34D6CC43_D4D9_40F8_9C73_454BB7A259AC__INCLUDED_)
#define AFX_ENUMLANGUAGEGROUPLOCALES_H__34D6CC43_D4D9_40F8_9C73_454BB7A259AC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EnumLanguageGroupLocales.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "ListCtrlEx.h"
#include "WhatIsThisEdit.h"
/////////////////////////////////////////////////////////////////////////////
// CEnumLanguageGroupLocales dialog

class CEnumLanguageGroupLocales : public CFunction
{
    DECLARE_DYNCREATE(CEnumLanguageGroupLocales)
// Construction
public:
        CEnumLanguageGroupLocales(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CEnumLanguageGroupLocales)
        enum { IDD = IDD_ENUM_LANGUAGE_GROUP_LOCALES };
        CWhatIsItButton c_LGRPID_VIETNAMESE;
        CWhatIsItButton c_LGRPID_TURKISH;
        CWhatIsItButton c_LGRPID_TRADITIONAL_CHINESE;
        CWhatIsItButton c_LGRPID_THAI;
        CWhatIsItButton c_LGRPID_SIMPLIFIED_CHINESE;
        CWhatIsItButton c_LGRPID_KOREAN;
        CWhatIsItButton c_LGRPID_JAPANESE;
        CWhatIsItButton c_LGRPID_INDIC;
        CWhatIsItButton c_LGRPID_HEBREW;
        CWhatIsItButton c_LGRPID_GREEK;
        CWhatIsItButton c_LGRPID_GEORGIAN;
        CWhatIsItButton c_LGRPID_CYRILLIC;
        CWhatIsItButton c_LGRPID_CENTRAL_EUROPE;
        CWhatIsItButton c_LGRPID_BALTIC;
        CWhatIsItButton c_LGRPID_ARMENIAN;
        CWhatIsItButton c_LGRPID_ARABIC;
        CWhatIsItButton c_LPGRPIP_WESTERN_EUROPE;
        CListCtrlEx       c_Output2;
        CWhatIsThisEdit   c_CallbackName;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CEnumLanguageGroupLocales)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls() { }
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & filename, UINT mode);
        virtual void Initialize();
protected: // methods
        void OnGroupLocale(UINT id);
        void UpdateCode();
        static BOOL CALLBACK EnumLanguageGroupLocalesProc(LGRPID group, LCID lcid, LPTSTR locale, LONG_PTR lParam);
        LGRPID ControlToLGRPID(UINT ctlid);

protected: // data
        UINT lgrpidSelection;
protected: // message handlers
        afx_msg void OnChangeCallbackName();
        // Generated Message map functions
        //{{AFX_MSG(CEnumLanguageGroupLocales)
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENUMLANGUAGEGROUPLOCALES_H__34D6CC43_D4D9_40F8_9C73_454BB7A259AC__INCLUDED_)
