#if !defined(AFX_ENUMSYSTEMGEOID_H__7A807194_80CC_4AB4_83A0_3D4047174B1A__INCLUDED_)
#define AFX_ENUMSYSTEMGEOID_H__7A807194_80CC_4AB4_83A0_3D4047174B1A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EnumSystemGeoID.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "GEOID.h"
/////////////////////////////////////////////////////////////////////////////
// CEnumSystemGeoID dialog

class CEnumSystemGeoID : public CFunction
{
    DECLARE_DYNCREATE(CEnumSystemGeoID)
// Construction
public:
        CEnumSystemGeoID(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CEnumSystemGeoID)
        enum { IDD = IDD_ENUM_SYSTEM_GEOID };
        CProgressCtrl   c_Progress;
        CGEOID       c_Output2;
        CWhatIsItButton c_GEOCLASS_NATION;
        CWhatIsThisEdit   c_CallbackName;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CEnumSystemGeoID)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh(); 
        virtual void SetFontToControls() { }
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & name, UINT mode);
protected: // data
        static CEnumSystemGeoID * LogWnd;
        int count;
protected: // callbacks
        static BOOL CALLBACK EnumGeoInfoProc(GEOID geoid);
        static BOOL CALLBACK EnumGeoCountProc(GEOID geoid);
protected: // message handlers
        afx_msg LRESULT OnLogData(WPARAM, LPARAM);
        // Generated message map functions
        //{{AFX_MSG(CEnumSystemGeoID)
        afx_msg void OnChangeCallbackName();
        afx_msg void OnGeoclassNation();
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENUMSYSTEMGEOID_H__7A807194_80CC_4AB4_83A0_3D4047174B1A__INCLUDED_)
