#if !defined(AFX_ENUMSYSTEMLOCALES_H__2C03ED45_FFBF_49BE_BD81_32360F71B021__INCLUDED_)
#define AFX_ENUMSYSTEMLOCALES_H__2C03ED45_FFBF_49BE_BD81_32360F71B021__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EnumSystemLocales.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "ListCtrlEx.h"
/////////////////////////////////////////////////////////////////////////////
// CEnumSystemLocales dialog

class CEnumSystemLocales : public CFunction
{
    DECLARE_DYNCREATE(CEnumSystemLocales)
// Construction
public:
        CEnumSystemLocales(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CEnumSystemLocales)
        enum { IDD = IDD_ENUM_SYSTEM_LOCALES };
        CWhatIsItButton c_LCID_0;
        CWhatIsThisEdit c_CallbackName;
        CListCtrlEx     c_Output;
        CWhatIsItButton c_LCID_SUPPORTED;
        CWhatIsItButton c_LCID_INSTALLED;
        CWhatIsItButton c_LCID_ALTERNATE_SORTS;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CEnumSystemLocales)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & filename, UINT mode);
protected: // Methods
        static BOOL CALLBACK EnumLocalesProc(LPTSTR);
protected: // data
        static CEnumSystemLocales * LogWnd;
        // Generated message map functions
        //{{AFX_MSG(CEnumSystemLocales)
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnLcidInstalled();
        afx_msg void OnLcidSupported();
        afx_msg void On0();
        afx_msg void OnLcidAlternateSorts();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENUMSYSTEMLOCALES_H__2C03ED45_FFBF_49BE_BD81_32360F71B021__INCLUDED_)
