#if !defined(AFX_EXPANDINGTREECTRL_H__6B6435C3_93B9_4128_B070_92AD78B802DC__INCLUDED_)
#define AFX_EXPANDINGTREECTRL_H__6B6435C3_93B9_4128_B070_92AD78B802DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ExpandingTreeCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CExpandingTreeCtrl window

class CExpandingTreeCtrl : public CTreeCtrl
{
// Construction
public:
        CExpandingTreeCtrl();

// Attributes
public:
        BOOL SetAutoExpand(BOOL mode);
        BOOL GetAutoExpand() { return wantexpand; }
// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CExpandingTreeCtrl)
        protected:
        virtual void PreSubclassWindow();
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CExpandingTreeCtrl();

        // Generated message map functions
protected:
        BOOL expanded;
        BOOL wantexpand;
        CRect original;
        BOOL selected;
        CWnd * anchor; // anchoring window
        CBrush HelpBrush;
        
        void ExpandWindow();
        void ResumeNormalSize();
        void ManageOverlappedControls(UINT mode);

        afx_msg LRESULT OnDeselectAll(WPARAM, LPARAM);
        //{{AFX_MSG(CExpandingTreeCtrl)
        afx_msg void OnKillfocus(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSetfocus(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnWhatIsThis();
        afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	//}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXPANDINGTREECTRL_H__6B6435C3_93B9_4128_B070_92AD78B802DC__INCLUDED_)
