#if !defined(AFX_FUNCTION_H__22439F45_0F97_4E6B_B7ED_120DF981FFDD__INCLUDED_)
#define AFX_FUNCTION_H__22439F45_0F97_4E6B_B7ED_120DF981FFDD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Function.h : header file
//
/////////////////////////////////////////////////////////////////////////////
// CFunction dialog
class CBiFile;

class CFunction : public CDialog
{
    DECLARE_DYNCREATE(CFunction)
// Construction
public:
        CFunction(UINT idd, CWnd* pParent = NULL);   // standard constructor
        CFunction(CWnd * parent = NULL) { ASSERT(FALSE); }
// Dialog Data
        //{{AFX_DATA(CFunction)
                // NOTE: the ClassWizard will add data members here
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CFunction)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        // virtual methods
        virtual void Initialize() { } // does nothing unless implemented in subclass
        virtual void Refresh() { ASSERT(FALSE); } // implement in subclass
        virtual void SetFontToControls() { ASSERT(FALSE); } // implement in subclass
        virtual void OnSetActive() {}   // implement in subclass
        virtual void OnKillActive() {}  // impplement in subclass
        virtual BOOL IndexOK(CWnd * p) { return TRUE; } // implement in subclass if anything is not indexable
        virtual void OnOK() { }
        virtual void OnCancel() { }
        virtual BOOL QuerySave() { return FALSE; }
        virtual BOOL Save(const CString & filename, UINT mode) { ::SetLastError(ERROR_CALL_NOT_IMPLEMENTED); return FALSE; }
        virtual CString GetVariable();
protected: // methods
        BOOL WriteChildren(CBiFile & f);
        CString GetLocaleName();
        void GetOptionFlags(CString & options, DWORD & flags, const CString & or);
        void AppendFlags(CString & flags, LPCTSTR newflag, const CString & or);
        void SetScroll();
        CString GetCaption(UINT ctlid);
        void EnablePair(UINT id, BOOL enable);
        void ExpandBottom(CWnd & wnd);
        void ExtendColumn(CListCtrl & wnd);
        void Index();
        CString GetOutputHeader();
protected: // Data values
        CWnd * TabParent;
        BOOL initialized;
        int  FontReferenceHeight;
        CString variable;
#ifdef _UNICODE
        CFont UnicodeFont;
#endif
        
        // For the scrolling dialog and the GetMinMaxInfo
        // Note that a lot of Q262954 is buggy beyond belief!
        CRect OriginalWindow; // original window size
        CRect OriginalClient; // Q262954 change
        int CurrentHeight; // Q262954
        int ScrollPos;     // Q262954

        // Generated message map functions
        afx_msg LRESULT OnRefresh(WPARAM, LPARAM);
        afx_msg LRESULT OnInitialize(WPARAM, LPARAM);
        afx_msg LRESULT OnSetUserFont(WPARAM, LPARAM);
        afx_msg LRESULT OnDeselectAll(WPARAM, LPARAM);
        afx_msg LRESULT OnQuerySave(WPARAM, LPARAM);
        afx_msg LRESULT OnSave(WPARAM, LPARAM);
        afx_msg LRESULT OnChangeLocale(WPARAM, LPARAM);
        //{{AFX_MSG(CFunction)
        afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnSize(UINT nType, int cx, int cy);
        virtual BOOL OnInitDialog();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FUNCTION_H__22439F45_0F97_4E6B_B7ED_120DF981FFDD__INCLUDED_)
