// GetDateFormat.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "GetDateFormat.h"
#include "Query.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CGetDateFormat, CFunction)

CGetDateFormat * CGetDateFormat::LogWnd = NULL;
/////////////////////////////////////////////////////////////////////////////
// CGetDateFormat dialog


CGetDateFormat::CGetDateFormat(CWnd* pParent /*=NULL*/)
        : CFunction(CGetDateFormat::IDD, pParent)
{
        //{{AFX_DATA_INIT(CGetDateFormat)
        //}}AFX_DATA_INIT
}


void CGetDateFormat::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CGetDateFormat)
        DDX_Control(pDX, IDC_SPACE, c_Space);
        DDX_Control(pDX, IDC_DEFAULT_DIRECTION, c_DateDefaultDirection);
        DDX_Control(pDX, IDC_CUSTOM_BOX, c_CustomBox);
        DDX_Control(pDX, IDC_OTHER_BOX, c_OtherBox);
        DDX_Control(pDX, IDC_FORMATTING_BOX, c_FormattingBox);
        DDX_Control(pDX, IDC_FORMAT_DATE_BOX, c_FormatDateBox);
        DDX_Control(pDX, IDC_DWFLAGS_BOX, c_dwFlagsBox);
        DDX_Control(pDX, IDC_DIRECTION_BOX, c_DirectionBox);
        DDX_Control(pDX, IDC_YEAR_BOX, c_YearBox);
        DDX_Control(pDX, IDC_MONTH_BOX, c_MonthBox);
        DDX_Control(pDX, IDC_DAYOFMONTH_BOX, c_DayOfMonthBox);
        DDX_Control(pDX, IDC_DAYOFWEEK_BOX, c_DayOfWeekBox);
        DDX_Control(pDX, IDC_PUNCTUATION, c_Punctuation);
        DDX_Control(pDX, IDC_FORMAT_BOX, c_FormatBox);
        DDX_Control(pDX, IDC_SYSTEMTIME_NAME_CAPTION, x_SystemTimeName);
        DDX_Control(pDX, IDC_SYSTEMTIME_NAME, c_SystemTimeName);
        DDX_Control(pDX, IDC_USE_EXPLICIT_FORMATTING, c_UseExplicitFormatting);
        DDX_Control(pDX, IDC_DEFAULT_FORMATTING, c_UseDefaultFormatting);
        DDX_Control(pDX, IDC_ENUMDATEFORMATS, c_EnumDateFormats);
        DDX_Control(pDX, IDC_SLASH, c_Slash);
        DDX_Control(pDX, IDC_QUOTE, c_Quote);
        DDX_Control(pDX, IDC_HYPHEN, c_Hyphen);
        DDX_Control(pDX, IDC_DOT, c_Dot);
        DDX_Control(pDX, IDC_COLON, c_Colon);
        DDX_Control(pDX, IDC_COMMA, c_Comma);
        DDX_Control(pDX, IDC_FORMATS, c_Formats);
        DDX_Control(pDX, IDC_DATE_RTLREADING, c_DateRTLReading);
        DDX_Control(pDX, IDC_DATE_LTRREADING, c_DateLTRReading);
        DDX_Control(pDX, IDC_DATE_YEARMONTH, c_DateYearMonth);
        DDX_Control(pDX, IDC_DATE_LONGDATE, c_DateLongDate);
        DDX_Control(pDX, IDC_CURRENT_SYSTEM_TIME, c_CurrentSystemTime);
        DDX_Control(pDX, IDC_SPECIFIC_TIME, c_SpecificTime);
        DDX_Control(pDX, IDC_YEAR, c_Year);
        DDX_Control(pDX, IDC_SPINSECOND, c_SpinSecond);
        DDX_Control(pDX, IDC_SPINMINUTE, c_SpinMinute);
        DDX_Control(pDX, IDC_SPINMILLISECONDS, c_SpinMilliseconds);
        DDX_Control(pDX, IDC_SPINHOUR, c_SpinHour);
        DDX_Control(pDX, IDC_SPINDAYOFWEEK, c_SpinDayOfWeek);
        DDX_Control(pDX, IDC_SPINDAY, c_SpinDay);
        DDX_Control(pDX, IDC_SECOND, c_Second);
        DDX_Control(pDX, IDC_MONTH, c_Month);
        DDX_Control(pDX, IDC_MINUTE, c_Minute);
        DDX_Control(pDX, IDC_MILLISECONDS, c_Milliseconds);
        DDX_Control(pDX, IDC_HOUR, c_Hour);
        DDX_Control(pDX, IDC_DAYOFWEEK, c_DayOfWeek);
        DDX_Control(pDX, IDC_DAY_CAPTION, x_Day);
        DDX_Control(pDX, IDC_YYYY, c_yyyy);
        DDX_Control(pDX, IDC_YY, c_yy);
        DDX_Control(pDX, IDC_YEAR_CAPTION, x_Year);
        DDX_Control(pDX, IDC_Y, c_y);
        DDX_Control(pDX, IDC_USE_CP_ACP, c_UseCPACP);
        DDX_Control(pDX, IDC_SYSTEMTIME, c_SYSTEMTIME);
        DDX_Control(pDX, IDC_SPINYEAR, c_SpinYear);
        DDX_Control(pDX, IDC_SPINMONTH, c_SpinMonth);
        DDX_Control(pDX, IDC_SECOND_CAPTION, x_Second);
        DDX_Control(pDX, IDC_RESULT, c_Result);
        DDX_Control(pDX, IDC_REMOVE, c_Remove);
        DDX_Control(pDX, IDC_NOUSEROVERRIDE, c_NoUserOverride);
        DDX_Control(pDX, IDC_MONTH_CAPTION, x_Month);
        DDX_Control(pDX, IDC_MMMM, c_MMMM);
        DDX_Control(pDX, IDC_MMM, c_MMM);
        DDX_Control(pDX, IDC_MM, c_MM);
        DDX_Control(pDX, IDC_MINUTE_CAPTION, x_Minute);
        DDX_Control(pDX, IDC_MILLISECOND_CAPTION, x_Milliseconds);
        DDX_Control(pDX, IDC_M, c_M);
        DDX_Control(pDX, IDC_HOUR_CAPTION, x_Hour);
        DDX_Control(pDX, IDC_GG, c_gg);
        DDX_Control(pDX, IDC_GETNOW, c_GetNow);
        DDX_Control(pDX, IDC_FORMAT, c_Format);
        DDX_Control(pDX, IDC_DDDD, c_dddd);
        DDX_Control(pDX, IDC_DDD, c_ddd);
        DDX_Control(pDX, IDC_DD, c_dd);
        DDX_Control(pDX, IDC_DAYOFWEEK_CAPTION, x_DayOfWeek);
        DDX_Control(pDX, IDC_DAY, c_Day);
        DDX_Control(pDX, IDC_DATE_USE_ALT_CALENDAR, c_DateUseAltCalendar);
        DDX_Control(pDX, IDC_DATE_SHORTDATE, c_DateShortDate);
        DDX_Control(pDX, IDC_D, c_d);
        DDX_Control(pDX, IDC_ADD, c_Add);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGetDateFormat, CFunction)
        //{{AFX_MSG_MAP(CGetDateFormat)
        ON_BN_CLICKED(IDC_ADD, OnAdd)
        ON_BN_CLICKED(IDC_CURRENT_SYSTEM_TIME, OnCurrentSystemTime)
        ON_BN_CLICKED(IDC_D, OnD)
        ON_BN_CLICKED(IDC_DATE_LONGDATE, OnDateLongdate)
        ON_BN_CLICKED(IDC_DATE_LTRREADING, OnDateLtrreading)
        ON_BN_CLICKED(IDC_DATE_RTLREADING, OnDateRtlreading)
        ON_BN_CLICKED(IDC_DATE_SHORTDATE, OnDateShortdate)
        ON_BN_CLICKED(IDC_DATE_USE_ALT_CALENDAR, OnDateUseAltCalendar)
        ON_BN_CLICKED(IDC_DATE_YEARMONTH, OnDateYearmonth)
        ON_EN_CHANGE(IDC_DAY, OnChangeDay)
        ON_EN_CHANGE(IDC_DAYOFWEEK, OnChangeDayofweek)
        ON_BN_CLICKED(IDC_DD, OnDd)
        ON_BN_CLICKED(IDC_DDD, OnDdd)
        ON_BN_CLICKED(IDC_DDDD, OnDddd)
        ON_CBN_EDITCHANGE(IDC_FORMAT, OnEditchangeFormat)
        ON_BN_CLICKED(IDC_GETNOW, OnGetnow)
        ON_BN_CLICKED(IDC_GG, OnGg)
        ON_EN_CHANGE(IDC_HOUR, OnChangeHour)
        ON_BN_CLICKED(IDC_M, OnM)
        ON_EN_CHANGE(IDC_MILLISECONDS, OnChangeMilliseconds)
        ON_EN_CHANGE(IDC_MINUTE, OnChangeMinute)
        ON_BN_CLICKED(IDC_MM, OnMm)
        ON_BN_CLICKED(IDC_MMM, OnMmm)
        ON_BN_CLICKED(IDC_MMMM, OnMmmm)
        ON_EN_CHANGE(IDC_MONTH, OnChangeMonth)
        ON_BN_CLICKED(IDC_REMOVE, OnRemove)
        ON_EN_CHANGE(IDC_SECOND, OnChangeSecond)
        ON_BN_CLICKED(IDC_SPECIFIC_TIME, OnSpecificTime)
        ON_BN_CLICKED(IDC_Y, OnY)
        ON_EN_CHANGE(IDC_YEAR, OnChangeYear)
        ON_BN_CLICKED(IDC_YY, OnYy)
        ON_BN_CLICKED(IDC_YYYY, OnYyyy)
        ON_WM_VSCROLL()
        ON_LBN_SELCHANGE(IDC_FORMATS, OnSelchangeFormats)
        ON_LBN_DBLCLK(IDC_FORMATS, OnDblclkFormats)
        ON_EN_CHANGE(IDC_FORMAT, OnChangeFormat)
        ON_BN_CLICKED(IDC_COLON, OnColon)
        ON_BN_CLICKED(IDC_COMMA, OnComma)
        ON_BN_CLICKED(IDC_DOT, OnDot)
        ON_BN_CLICKED(IDC_HYPHEN, OnHyphen)
        ON_BN_CLICKED(IDC_QUOTE, OnQuote)
        ON_BN_CLICKED(IDC_SLASH, OnSlash)
        ON_BN_CLICKED(IDC_ENUMDATEFORMATS, OnEnumdateformats)
        ON_BN_CLICKED(IDC_DEFAULT_FORMATTING, OnDefaultFormatting)
        ON_BN_CLICKED(IDC_USE_EXPLICIT_FORMATTING, OnUseExplicitFormatting)
        ON_EN_CHANGE(IDC_SYSTEMTIME_NAME, OnChangeSystemtimeName)
        ON_BN_CLICKED(IDC_SPACE, OnSpace)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetDateFormat message handlers

BOOL CGetDateFormat::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    c_SpinYear.SetRange32(1601, 30827);
    c_SpinMonth.SetRange32(1, 12);
    c_SpinDayOfWeek.SetRange32(0, 6);
    c_SpinDay.SetRange32(1, 31);
    c_SpinHour.SetRange32(0, 23);
    c_SpinMinute.SetRange32(0, 59);
    c_SpinSecond.SetRange32(0, 59);
    c_SpinMilliseconds.SetRange32(0, 999);

    CheckRadioButton(IDC_DATE_SHORTDATE, IDC_DATE_YEARMONTH, IDC_DATE_SHORTDATE);
    CheckRadioButton(IDC_DEFAULT_DIRECTION, IDC_DATE_RTLREADING, IDC_DEFAULT_DIRECTION);
    CheckRadioButton(IDC_CURRENT_SYSTEM_TIME, IDC_SPECIFIC_TIME, IDC_CURRENT_SYSTEM_TIME);
    CheckRadioButton(IDC_DEFAULT_FORMATTING, IDC_USE_EXPLICIT_FORMATTING, IDC_DEFAULT_FORMATTING);
    // TODO: Add extra initialization here
        
    return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

void CGetDateFormat::OnAdd() 
   {
    CString s;
    c_Format.GetWindowText(s);
    int n = c_Formats.FindStringExact(-1, s);
    if(n == CB_ERR)
       { /* not already there */
        c_Formats.AddString(s);
       } /* not already there */
    updateControls();
   }

/****************************************************************************
*                          CGetDateFormat::OnRemove
* Result: void
*       
* Effect: 
*       Removes the current selection
****************************************************************************/

void CGetDateFormat::OnRemove() 
   {
    int n = c_Formats.GetCurSel();
    if(n == CB_ERR)
       return; // we should not be here
    c_Formats.DeleteString(n);
    updateControls();
   }

/****************************************************************************
*                       CGetDateFormat::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CGetDateFormat::updateControls()
    {
     BOOL enable;
     enable = c_SpecificTime.GetCheck() == BST_CHECKED;

     c_SYSTEMTIME.EnableWindow(enable);
     c_SystemTimeName.EnableWindow(enable);
     x_SystemTimeName.EnableWindow(enable);

     c_Year.EnableWindow(enable);
     x_Year.EnableWindow(enable);
     c_SpinYear.EnableWindow(enable);

     c_Month.EnableWindow(enable);
     x_Month.EnableWindow(enable);
     c_SpinMonth.EnableWindow(enable);

     c_Day.EnableWindow(enable);
     x_Day.EnableWindow(enable);
     c_SpinDay.EnableWindow(enable);

     c_DayOfWeek.EnableWindow(enable);
     x_DayOfWeek.EnableWindow(enable);
     c_SpinDayOfWeek.EnableWindow(enable);

     c_Hour.EnableWindow(enable);
     x_Hour.EnableWindow(enable);
     c_SpinHour.EnableWindow(enable);

     c_Minute.EnableWindow(enable);
     x_Minute.EnableWindow(enable);
     c_SpinMinute.EnableWindow(enable);

     c_Second.EnableWindow(enable);
     x_Second.EnableWindow(enable);
     c_SpinSecond.EnableWindow(enable);

     c_Milliseconds.EnableWindow(enable);
     x_Milliseconds.EnableWindow(enable);
     c_SpinMilliseconds.EnableWindow(enable);

     c_GetNow.EnableWindow(enable);

     enable = c_UseExplicitFormatting.GetCheck() == BST_CHECKED;
     
     c_FormatBox.EnableWindow(enable);
     c_Format.EnableWindow(enable);
     c_Formats.EnableWindow(enable);

     c_EnumDateFormats.EnableWindow(enable);
     c_d.EnableWindow(enable);
     c_dd.EnableWindow(enable);
     c_ddd.EnableWindow(enable);
     c_dddd.EnableWindow(enable);
     c_M.EnableWindow(enable);
     c_MM.EnableWindow(enable);
     c_MMM.EnableWindow(enable);
     c_MMMM.EnableWindow(enable);
     c_y.EnableWindow(enable);
     c_yy.EnableWindow(enable);
     c_yyyy.EnableWindow(enable);
     c_gg.EnableWindow(enable);
     c_Dot.EnableWindow(enable);
     c_Comma.EnableWindow(enable);
     c_Colon.EnableWindow(enable);
     c_Slash.EnableWindow(enable);
     c_Quote.EnableWindow(enable);
     c_Hyphen.EnableWindow(enable);
     c_Space.EnableWindow(enable);
     c_Punctuation.EnableWindow(enable);
     c_DayOfMonthBox.EnableWindow(enable);
     c_DayOfWeekBox.EnableWindow(enable);
     c_MonthBox.EnableWindow(enable);
     c_YearBox.EnableWindow(enable);
     c_CustomBox.EnableWindow(enable);
     
     //----------------------------------------------------------------
     // Add button
     //----------------------------------------------------------------
     CString s;
     c_Format.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();

     BOOL add = enable;
     if(!s.IsEmpty())
        { /* nonempty */
         int sel = c_Formats.FindStringExact(-1, s);
         if(sel != CB_ERR)
            add = FALSE;
        } /* nonempty */
     else
        { /* empty */
         add = FALSE;
        } /* empty */
     c_Add.EnableWindow(add);
     
     //----------------------------------------------------------------
     // Remove button
     //----------------------------------------------------------------
     int n = c_Formats.GetCurSel();
     BOOL remove = n != CB_ERR;
     remove &= enable;
     c_Remove.EnableWindow(remove);

     //----------------------------------------------------------------
     // Enable/Disable custom settings
     //----------------------------------------------------------------
     c_OtherBox.EnableWindow(!enable);
     c_FormattingBox.EnableWindow(!enable);
     c_FormatDateBox.EnableWindow(!enable);
     c_dwFlagsBox.EnableWindow(!enable);
     c_DirectionBox.EnableWindow(!enable);
     c_DateShortDate.EnableWindow(!enable);
     c_DateLongDate.EnableWindow(!enable);
     c_DateYearMonth.EnableWindow(!enable);
     c_DateLTRReading.EnableWindow(!enable);
     c_DateRTLReading.EnableWindow(!enable);
     c_DateUseAltCalendar.EnableWindow(!enable);
     c_UseCPACP.EnableWindow(!enable);
     c_NoUserOverride.EnableWindow(!enable);

    } // CGetDateFormat::updateControls


void CGetDateFormat::OnCurrentSystemTime() 
   {
    Refresh();
   }

void CGetDateFormat::OnDateLongdate() 
   {
    Refresh();
   }

void CGetDateFormat::OnDateLtrreading() 
   {
    Refresh();
   }

void CGetDateFormat::OnDateRtlreading() 
   {
    Refresh();
   }

void CGetDateFormat::OnDateShortdate() 
   {
    Refresh();
   }

void CGetDateFormat::OnDateUseAltCalendar() 
   {
    Refresh();
   }

void CGetDateFormat::OnDateYearmonth() 
   {
    Refresh();
   }

/****************************************************************************
*                             CGetDateFormat::OnD
*                             CGetDateFormat::OnDd
*                            CGetDateFormat::OnDdd
*                            CGetDateFormat::OnDddd
*                             CGetDateFormat::OnY
*                             CGetDateFormat::OnYy
*                            CGetDateFormat::OnYyy
*
* Result: void
*       
* Effect: 
*       Inserts the appropriate text
****************************************************************************/

void CGetDateFormat::OnD() 
   {
    Insert(_T("d"));
   }

void CGetDateFormat::OnDd() 
   {
    Insert(_T("dd"));
   }

void CGetDateFormat::OnDdd() 
   {
    Insert(_T("ddd"));
   }

void CGetDateFormat::OnDddd() 
   {
    Insert(_T("dddd"));
   }

void CGetDateFormat::OnM() 
   {
    Insert(_T("M"));
   }

void CGetDateFormat::OnMm() 
   {
    Insert(_T("MM"));
   }

void CGetDateFormat::OnMmm() 
   {
    Insert(_T("MMM"));
   }

void CGetDateFormat::OnMmmm() 
   {
    Insert(_T("MMMM"));
   }

void CGetDateFormat::OnY() 
   {
   Insert(_T("y"));
   }

void CGetDateFormat::OnYy() 
   {
    Insert(_T("yy"));
   }

void CGetDateFormat::OnYyyy() 
   {
    Insert(_T("yyyy"));
   }

void CGetDateFormat::OnGg() 
   {
    Insert(_T("gg"));
   }

void CGetDateFormat::OnColon() 
   {
    Insert(_T(":"));
   }

void CGetDateFormat::OnComma() 
   {
    Insert(_T(","));
   }

void CGetDateFormat::OnDot() 
   {
    Insert(_T("."));
   }

void CGetDateFormat::OnHyphen() 
   {
    Insert(_T("-"));
   }

void CGetDateFormat::OnQuote() 
   {
    Insert(_T("'"));
   }

void CGetDateFormat::OnSlash() 
   {
    Insert(_T("/"));
   }

void CGetDateFormat::OnSpace() 
   {
    Insert(_T(" "));
   }


/****************************************************************************
*                     CGetDateFormat::updateSpecificTime
* Result: void
*       
* Effect: 
*       Copies the controls back to the specificTime value
****************************************************************************/

void CGetDateFormat::updateSpecificTime()
    {
     if(!initialized)
         return;
     specificTime.wYear = c_SpinYear.GetPos32();
     specificTime.wMonth = c_SpinMonth.GetPos32();
     specificTime.wDayOfWeek = c_SpinDayOfWeek.GetPos32();
     specificTime.wDay = c_SpinDay.GetPos32();
     specificTime.wHour = c_SpinHour.GetPos32();
     specificTime.wMinute = c_SpinMinute.GetPos32();
     specificTime.wSecond = c_SpinSecond.GetPos32();
     specificTime.wMilliseconds = c_SpinMilliseconds.GetPos32();
    } // CGetDateFormat::updateSpecificTime

/****************************************************************************
*                        CGetDateFormat::OnChangeYear
*                        CGetDateFormat::OnChangeMonth
*                        CGetDateFormat::OnChangeDay
*                        CGetDateFormat::OnChangeHour
*                       CGetDateFormat::OnChangeMinute
*                       CGetDateFormat::OnChangeSecond
*                     CGetDateFormat::OnChangeMillisecond
* Result: void
*       
* Effect: 
*       Forces a refresh
****************************************************************************/

void CGetDateFormat::OnChangeYear() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetDateFormat::OnChangeMonth() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetDateFormat::OnChangeDay() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetDateFormat::OnChangeDayofweek() 
   {
    updateSpecificTime();
    Refresh();        
   }

void CGetDateFormat::OnChangeHour() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetDateFormat::OnChangeMinute() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetDateFormat::OnChangeSecond() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetDateFormat::OnChangeMilliseconds() 
   {
    updateSpecificTime();
    Refresh();
   }


void CGetDateFormat::OnEditchangeFormat() 
   {
    Refresh();
   }

void CGetDateFormat::OnGetnow() 
   {
    GetSystemTime(&specificTime);
    c_SpinYear.SetPos32(specificTime.wYear);
    c_SpinMonth.SetPos32(specificTime.wMonth);
    c_SpinDayOfWeek.SetPos32(specificTime.wDayOfWeek);
    c_SpinDay.SetPos32(specificTime.wDay);
    c_SpinHour.SetPos32(specificTime.wHour);
    c_SpinMinute.SetPos32(specificTime.wMinute);
    c_SpinSecond.SetPos32(specificTime.wSecond);
    c_SpinMilliseconds.SetPos32(specificTime.wMilliseconds);
    Refresh();
   }

void CGetDateFormat::OnSpecificTime() 
   {
    Refresh();
   }

void CGetDateFormat::OnChangeSystemtimeName() 
   {
    Refresh();
   }
   

/****************************************************************************
*                          CGetDateFormat::OnVScroll
* Inputs:
*       UINT nSBCode:
*       UINT nPos:
*       CScrollBar * pScrollBar
* Result: void
*       
* Effect: 
*       If the scrollbar is non-NULL, it is from an internal control and
*       should be ignored
****************************************************************************/

void CGetDateFormat::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
   {
    if(pScrollBar != NULL)
       { /* local spin control */
        return; // do nothing
       } /* local spin control */
    CFunction::OnVScroll(nSBCode, nPos, pScrollBar);
   }

/****************************************************************************
*                           CGetDateFormat::Insert
* Inputs:
*       const CString & text: Text to add
* Result: void
*       
* Effect: 
*       Adds the text
****************************************************************************/

void CGetDateFormat::Insert(const CString & text)
    {
     c_Format.ReplaceSel(text);
     Refresh();
    } // CGetDateFormat::Insert

/****************************************************************************
*                           CGetDateFormat::Refresh
* Result: void
*       
* Effect: 
*       Refreshes the contents
****************************************************************************/

void CGetDateFormat::Refresh()
    {
     if(!initialized)
         return;
     EnableQuery(QUERY_USE_CP_ACP, TRUE);
     EnableQuery(QUERY_NOUSEROVERRIDE, TRUE);
     EnableQuery(QUERY_DWORD, FALSE);
     updateControls();

     CString or = QueryTemplate(_T("[OR]"));

     LPTSTR format = NULL;
     CString formatString;
     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The date format string
     //----------------------------------------------------------------
     if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
        { /* default formatting */
         format = NULL;
         formatString = _T(""); // We use a different template, a ":DEFAULT" template, so this is not used
        } /* default formatting */
     else
        { /* explicit formatting */
         c_Format.GetWindowText(formatString);
         format = (LPTSTR)(LPCTSTR)formatString;
        } /* explicit formatting */

     //----------------------------------------------------------------
     // %3: The option flags
     //----------------------------------------------------------------
     DWORD flags = 0;
     CString flagString;
     if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
        { /* default formatting */
         GetOptionFlags(flagString, flags, or);

         //----------------------------------------------------------------
         // Format flags
         //----------------------------------------------------------------
         CString fmtflags;
         if(c_DateShortDate.GetCheck() == BST_CHECKED)
            { /* shortdate */
             AppendFlags(flagString, _T("DATE_SHORTDATE"), or);
             flags |= DATE_SHORTDATE;
            } /* shortdate */
         else
         if(c_DateLongDate.GetCheck() == BST_CHECKED)
            { /* long date */
             AppendFlags(flagString, _T("DATE_LONGDATE"), or);
             flags |= DATE_LONGDATE;
            } /* long date */
         else
         if(c_DateYearMonth.GetCheck() == BST_CHECKED)
            { /* yearmonth */
             AppendFlags(flagString, _T("DATE_YEARMONTH"), or);
             flags |= DATE_YEARMONTH;
            } /* yearmonth */

         //----------------------------------------------------------------
         // Direction flags
         //----------------------------------------------------------------
         if(c_DateLTRReading.GetCheck() == BST_CHECKED)
            { /* LTR */
             AppendFlags(flagString, _T("DATE_LTRREADING"), or);
            } /* LTR */
         else
         if(c_DateRTLReading.GetCheck() == BST_CHECKED)
            { /* RTL */
             AppendFlags(flagString, _T("DATE_RTLREADING"), or);
            } /* RTL */

         //----------------------------------------------------------------
         // Other flags
         //----------------------------------------------------------------
         if(c_DateUseAltCalendar.GetCheck() == BST_CHECKED)
            AppendFlags(flagString, _T("DATE_USE_ALT_CALENDAR"), or);
        } /* default formatting */
     else
        { /* explicit formatting */
         flags = 0;
         flagString = _T("0");
        } /* explicit formatting */

     if(flags & LOCALE_USE_CP_ACP)
        c_UseCPACP.SetWindowText(_T("LOCALE_USE_CAP_ACP"));
     else
        c_UseCPACP.SetWindowText(_T(""));

     if(flags & LOCALE_NOUSEROVERRIDE)
        c_NoUserOverride.SetWindowText(_T("LOCALE_NOUSEROVERRIDE"));
     else
        c_NoUserOverride.SetWindowText(_T(""));

     if(flagString.IsEmpty())
        flagString = _T("0");

     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------


     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     BOOL enable = TRUE;
     CString variable;

     //     variable = QueryVariable();
     //     variable.TrimLeft();
     //     variable.TrimRight();
     //     if(variable.IsEmpty())
     //        { /* empty */
     //         variable = _T("?");
     //         enable = FALSE;
     //        } /* empty */
     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: Options as a decimal number
     //----------------------------------------------------------------
     CString flagsDecimal;
     flagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: OR
     //----------------------------------------------------------------
     // This was already set up

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: time pointer
     //----------------------------------------------------------------
     LPSYSTEMTIME time;
     CString timeString;

     CString fmt;
     if(c_SpecificTime.GetCheck() == BST_CHECKED)
        { /* user-defined time */
         time = &specificTime;
         c_SystemTimeName.GetWindowText(timeString);
         timeString.TrimLeft();
         timeString.TrimRight();
         if(timeString.IsEmpty())
            timeString = _T("&timevalue"); // make this a control someday
         if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
            fmt = QueryTemplate(_T("[GetDateFormat:SPECIFICTIME:DEFAULT]"));
         else
            fmt = QueryTemplate(_T("[GetDateFormat:SPECIFICTIME]"));
        } /* user-defined time */
     else
        { /* system time */
         time = NULL;
         timeString = _T("NULL");
         if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
            fmt = QueryTemplate(_T("[GetDateFormat:NOW:DEFAULT]"));
         else
            fmt = QueryTemplate(_T("[GetDateFormat:NOW]"));
        } /* system time */


     //----------------------------------------------------------------
     // %10: not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: not used
     //----------------------------------------------------------------

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1              %2           %3         %4      %5         %6         %7        %8           %9        %10     %11
     text.FormatMessage(fmt, localeName,  formatString, flagString, _T(""), variable, flagsDecimal,  or, localeDecimal, timeString, _T(""), _T(""));

     //-----------------------------------------------------------------------------------------------
     SetCode(text, enable);

     // .. Set the time value here
     { /* GetDateFormat */
      int length = GetDateFormat(lcid, flags, time, format, NULL, 0);
      if(length == 0)
         { /* error */
          DWORD err = GetLastError();
          c_Result.SetWindowText(ErrorString(err));
         } /* error */
      else
         { /* got length */
          CString result;
          LPTSTR p = result.GetBuffer(length);
          if(!::GetDateFormat(lcid, flags, time, format, p, length))
             { /* failed */
              DWORD err = GetLastError();
              result.ReleaseBuffer();
              c_Result.SetWindowText(ErrorString(err));
             } /* failed */
          else
              { /* got date */
              result.ReleaseBuffer();
              c_Result.SetWindowText(result);
              } /* got date */
         } /* got length */
     } /* GetDateFormat */
     
    } // CGetDateFormat::Refresh

/****************************************************************************
*                       CGetDateFormat::OnDblclkFormats
* Result: void
*       
* Effect: 
*       Puts current selection in edit control
****************************************************************************/

void CGetDateFormat::OnDblclkFormats() 
   {
    int n = c_Formats.GetCurSel();
    if(n == CB_ERR)
       return;
    CString s;
    c_Formats.GetText(n, s);
    c_Format.SetWindowText(s);
   }

/****************************************************************************
*                       CGetDateFormat::OnChangeFormat
*                     CGetDateFormat::OnSelchangeFormats()
* Result: void
*       
* Effect: 
*       Refreshes the display
****************************************************************************/

void CGetDateFormat::OnChangeFormat() 
   {
    Refresh();
   }

void CGetDateFormat::OnSelchangeFormats() 
   {
    updateControls();
   }

/****************************************************************************
*                     CGetDateFormat::EnumDateFormatsProc
* Inputs:
*       LPTSTR fmt: Format
* Result: BOOL
*       TRUE, always
* Effect: 
*       Adds the format the the listbox
****************************************************************************/

BOOL CALLBACK CGetDateFormat::EnumDateFormatsProc(LPTSTR fmt)
   {
    int n = LogWnd->c_Formats.FindStringExact(-1, fmt);
    if(n != CB_ERR)
       return TRUE; // ignore and keep running
    int item = LogWnd->c_Formats.AddString(fmt);
    LogWnd->c_Formats.SetItemData(item, TRUE); // indicate built-in format
    return TRUE;
   } // CGetDateFormat::EnumDateFormatsProc


/****************************************************************************
*                      CGetDateFormat::OnEnumDateFormats
* Result: void
*       
* Effect: 
*       Enumerates the date format
****************************************************************************/

void CGetDateFormat::OnEnumdateformats() 
   {
    LCID locale = QueryLocale();
    LogWnd = this;
    DWORD flags = 0;
    flags |= QueryFlag(QUERY_USE_CP_ACP);
    
    if(!EnumDateFormats(EnumDateFormatsProc, locale, flags | DATE_SHORTDATE ))
       { /* error */
        DWORD err = ::GetLastError();
        return;
       } /* error */    

    if(!EnumDateFormats(EnumDateFormatsProc, locale, flags | DATE_LONGDATE ))
       { /* error */
        DWORD err = ::GetLastError();
        return;
       } /* error */    

    if(!EnumDateFormats(EnumDateFormatsProc, locale, flags | DATE_YEARMONTH ))
       { /* error */
        DWORD err = ::GetLastError();
        return;
       } /* error */    
    
   }



void CGetDateFormat::OnDefaultFormatting() 
   {
    Refresh();
   }

void CGetDateFormat::OnUseExplicitFormatting() 
   {
    Refresh();
   }

/****************************************************************************
*                         CGetDateFormat::Initialize
* Result: void
*       
* Effect: 
*       Refreshes the display
****************************************************************************/

void CGetDateFormat::Initialize()
    {
     variable = _T("datestring");
     c_SystemTimeName.SetWindowText(_T("timevalue"));
     OnGetnow(); // implies Refresh();
    } // CGetDateFormat::Initialize


/****************************************************************************
*                      CGetDateFormat::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font
****************************************************************************/

void CGetDateFormat::SetFontToControls()
    {
#ifdef _UNICODE
     c_Result.SetFont(&UnicodeFont);
#endif
    } // CGetDateFormat::SetFontToControls


/****************************************************************************
*                           GetDateFormat::IndexOK
* Inputs:
*       CWnd * p: Window to index
* Result: BOOL
*       TRUE if window should be indexed
*       FALSE to suppress index
****************************************************************************/

BOOL CGetDateFormat::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_Result)
        return FALSE;
     return TRUE;
    } // GetDateFormat::IndexOK
