#if !defined(AFX_GETLOCALEINFO_H__19940BA0_97C6_49EF_B337_9BF353495A37__INCLUDED_)
#define AFX_GETLOCALEINFO_H__19940BA0_97C6_49EF_B337_9BF353495A37__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GetLocaleInfo.h : header file
//
#include "WhatIsThisEditNotify.h"
#include "ExpandingTreeCtrl.h"
#include "CodeTemplate.h"
#include "Function.h"
/////////////////////////////////////////////////////////////////////////////
// CGetLocaleInfo dialog

class GETLOCALEINFO_TABLE;
typedef GETLOCALEINFO_TABLE * LPGETLOCALEINFO_TABLE;
typedef const GETLOCALEINFO_TABLE * LPCGETLOCALEINFO_TABLE;

class CGetLocaleInfo : public CFunction
{
    DECLARE_DYNCREATE(CGetLocaleInfo)              
// Construction
public:
        CGetLocaleInfo(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CGetLocaleInfo)
        enum { IDD = IDD_GETLOCALEINFO };
        CWhatIsThisEditNotify c_LOCALE_ILANGUAGE;
        CWhatIsThisEditNotify c_LOCALE_SLANGUAGE;
        CWhatIsThisEditNotify c_LOCALE_SENGLANGUAGE;
        CWhatIsThisEditNotify c_LOCALE_SABBREVLANGNAME;
        CWhatIsThisEditNotify c_LOCALE_SNATIVELANGNAME;
        CWhatIsThisEditNotify c_LOCALE_ICOUNTRY;
        CWhatIsThisEditNotify c_LOCALE_SCOUNTRY;
        CWhatIsThisEditNotify c_LOCALE_SENGCOUNTRY;
        CWhatIsThisEditNotify c_LOCALE_SABBREVCTRYNAME;
        CWhatIsThisEditNotify c_LOCALE_SNATIVECTRYNAME;
        CWhatIsThisEditNotify c_LOCALE_IDEFAULTLANGUAGE;
        CWhatIsThisEditNotify c_LOCALE_IDEFAULTCOUNTRY;
        CWhatIsThisEditNotify c_LOCALE_IDEFAULTCODEPAGE;
        CWhatIsThisEditNotify c_LOCALE_IDEFAULTANSICODEPAGE;
        CWhatIsThisEditNotify c_LOCALE_IDEFAULTMACCODEPAGE;
        CWhatIsThisEditNotify c_LOCALE_SLIST;
        CWhatIsThisEditNotify c_LOCALE_IMEASURE;
        CWhatIsThisEditNotify c_LOCALE_SDECIMAL;
        CWhatIsThisEditNotify c_LOCALE_STHOUSAND;
        CWhatIsThisEditNotify c_LOCALE_SGROUPING;
        CWhatIsThisEditNotify c_LOCALE_IDIGITS;
        CWhatIsThisEditNotify c_LOCALE_ILZERO;
        CWhatIsThisEditNotify c_LOCALE_INEGNUMBER;
        CWhatIsThisEditNotify c_LOCALE_SNATIVEDIGITS;
        CWhatIsThisEditNotify c_LOCALE_SCURRENCY;
        CWhatIsThisEditNotify c_LOCALE_SINTLSYMBOL;
        CWhatIsThisEditNotify c_LOCALE_SMONDECIMALSEP;
        CWhatIsThisEditNotify c_LOCALE_SMONTHOUSANDSEP;
        CWhatIsThisEditNotify c_LOCALE_SMONGROUPING;
        CWhatIsThisEditNotify c_LOCALE_ICURRDIGITS;
        CWhatIsThisEditNotify c_LOCALE_IINTLCURRDIGITS;
        CWhatIsThisEditNotify c_LOCALE_ICURRENCY;
        CWhatIsThisEditNotify c_LOCALE_INEGCURR;
        CWhatIsThisEditNotify c_LOCALE_SDATE;
        CWhatIsThisEditNotify c_LOCALE_STIME;
        CWhatIsThisEditNotify c_LOCALE_SSHORTDATE;
        CWhatIsThisEditNotify c_LOCALE_SLONGDATE;
        CWhatIsThisEditNotify c_LOCALE_STIMEFORMAT;
        CWhatIsThisEditNotify c_LOCALE_IDATE;
        CWhatIsThisEditNotify c_LOCALE_ILDATE;
        CWhatIsThisEditNotify c_LOCALE_ITIMEMARKPOSN;
        CWhatIsThisEditNotify c_LOCALE_ICENTURY;
        CWhatIsThisEditNotify c_LOCALE_ITLZERO;
        CWhatIsThisEditNotify c_LOCALE_IDAYLZERO;
        CWhatIsThisEditNotify c_LOCALE_IMONLZERO;
        CWhatIsThisEditNotify c_LOCALE_S1159;
        CWhatIsThisEditNotify c_LOCALE_S2359;
        CWhatIsThisEditNotify c_LOCALE_ICALENDARTYPE;
        CWhatIsThisEditNotify c_LOCALE_IOPTIONALCALENDAR;
        CWhatIsThisEditNotify c_LOCALE_IFIRSTDAYOFWEEK;
        CWhatIsThisEditNotify c_LOCALE_IFIRSTWEEKOFYEAR;
        CWhatIsThisEditNotify c_LOCALE_SDAYNAME1;
        CWhatIsThisEditNotify c_LOCALE_SDAYNAME2;
        CWhatIsThisEditNotify c_LOCALE_SDAYNAME3;
        CWhatIsThisEditNotify c_LOCALE_SDAYNAME4;
        CWhatIsThisEditNotify c_LOCALE_SDAYNAME5;
        CWhatIsThisEditNotify c_LOCALE_SDAYNAME6;
        CWhatIsThisEditNotify c_LOCALE_SDAYNAME7;
        CWhatIsThisEditNotify c_LOCALE_SABBREVDAYNAME1;
        CWhatIsThisEditNotify c_LOCALE_SABBREVDAYNAME2;
        CWhatIsThisEditNotify c_LOCALE_SABBREVDAYNAME3;
        CWhatIsThisEditNotify c_LOCALE_SABBREVDAYNAME4;
        CWhatIsThisEditNotify c_LOCALE_SABBREVDAYNAME5;
        CWhatIsThisEditNotify c_LOCALE_SABBREVDAYNAME6;
        CWhatIsThisEditNotify c_LOCALE_SABBREVDAYNAME7;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME1;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME2;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME3;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME4;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME5;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME6;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME7;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME8;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME9;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME10;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME11;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME12;
        CWhatIsThisEditNotify c_LOCALE_SMONTHNAME13;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME1;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME2;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME3;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME4;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME5;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME6;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME7;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME8;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME9;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME10;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME11;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME12;
        CWhatIsThisEditNotify c_LOCALE_SABBREVMONTHNAME13;
        CWhatIsThisEditNotify c_LOCALE_SPOSITIVESIGN;
        CWhatIsThisEditNotify c_LOCALE_SNEGATIVESIGN;
        CWhatIsThisEditNotify c_LOCALE_IPOSSIGNPOSN;
        CWhatIsThisEditNotify c_LOCALE_INEGSIGNPOSN;
        CWhatIsThisEditNotify c_LOCALE_IPOSSYMPRECEDES;
        CWhatIsThisEditNotify c_LOCALE_IPOSSEPBYSPACE;
        CWhatIsThisEditNotify c_LOCALE_INEGSYMPRECEDES;
        CWhatIsThisEditNotify c_LOCALE_INEGSEPBYSPACE;
        CWhatIsThisEditNotify c_LOCALE_SISO639LANGNAME;
        CWhatIsThisEditNotify c_LOCALE_SISO3166CTRYNAME;
        CWhatIsThisEditNotify c_LOCALE_IDEFAULTEBCDICCODEPAGE;
        CWhatIsThisEditNotify c_LOCALE_IPAPERSIZE;
        CWhatIsThisEditNotify c_LOCALE_SENGCURRNAME;
        CWhatIsThisEditNotify c_LOCALE_SNATIVECURRNAME;
        CWhatIsThisEditNotify c_LOCALE_SYEARMONTH;
        CWhatIsThisEditNotify c_LOCALE_SSORTNAME;
        CWhatIsThisEditNotify c_LOCALE_IDIGITSUBSTITUTION;
        CStatic c_FontSignatureCaption;
        CButton c_AutoExpand;
        CExpandingTreeCtrl       c_LOCALE_FONTSIGNATURE;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGetLocaleInfo)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // Virtual Methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & name, UINT mode);
protected: // Methods
        void ShowLocaleSignature(PLOCALESIGNATURE data);
        void ShowUnicodeSubsets(LPLOCALESIGNATURE data, HTREEITEM root);
        void ShowCodePages(LPDWORD codepagevector, HTREEITEM root);
        LPCGETLOCALEINFO_TABLE FindLocaleInfo(LCTYPE item);
        void EnableDisplay(BOOL enable);
        void UpdateCode();
protected: // data
        UINT ItemSelection;

protected: // Message handlers
        afx_msg LRESULT OnSelectLCType(WPARAM, LPARAM);
        // Generated message map functions
        //{{AFX_MSG(CGetLocaleInfo)
        virtual BOOL OnInitDialog();
        afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
        afx_msg void OnAutoexpand();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GETLOCALEINFO_H__19940BA0_97C6_49EF_B337_9BF353495A37__INCLUDED_)
