// IDCombo.h : header file
//
// Copyright  2005, Joseph M. Newcomer, All Rights Reserved
// You must record any changes you make to this source by putting // and your
// initials at the end of each line you change. You may not remove any lines
// from this source; instead, put // in front of them and your initials at the end.
// You may not charge any fee for the redistribution, nor incorporate this code in
// any commercial product. This is freeware, and must remain so.
//

/////////////////////////////////////////////////////////////////////////////
// CIDCombo window
#pragma once

typedef struct {
        UINT id;  // IDS_ for string, or 0 for end of table for AddStrings
        int val; // value for itemdata
               } IDData;


class CIDCombo : public CComboBox
{
// Construction
public:
        CIDCombo();

// Attributes
public:

// Operations
public:
        int AddString(const IDData * data);
        int AddString(CString &s) { return CComboBox::AddString(s); }
        int AddString(LPCTSTR s)  { return CComboBox::AddString(s); }
        BOOL AddStrings(const IDData * data, UINT def = 0);
        int Select(DWORD itemval);
        DWORD GetCurItem();

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CIDCombo)
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CIDCombo();
        int maxlen;  // maximum number of items displayed
                     // 0 - no limit
                     // -1 - limit to screen height

        // Generated message map functions
protected:
        //{{AFX_MSG(CIDCombo)
        afx_msg void OnDropdown();
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
