// Initializing.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Initializing.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CInitializing dialog


CInitializing::CInitializing(CWnd* pParent /*=NULL*/)
        : CDialog(CInitializing::IDD, pParent)
{
        //{{AFX_DATA_INIT(CInitializing)
                // NOTE: the ClassWizard will add member initialization here
        //}}AFX_DATA_INIT
}


void CInitializing::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CInitializing)
        DDX_Control(pDX, IDC_REASON, c_Reason);
        DDX_Control(pDX, IDC_PROGRESS, c_Progress);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CInitializing, CDialog)
        //{{AFX_MSG_MAP(CInitializing)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInitializing message handlers

BOOL CInitializing::OnInitDialog() 
{
        CDialog::OnInitDialog();
        
        // TODO: Add extra initialization here
        
        CenterWindow();
        ShowWindow(SW_SHOW);
        UpdateWindow();
        return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

/****************************************************************************
*                           CInitializing::SetLimit
* Inputs:
*       int n: Number to set
* Result: void
*       
* Effect: 
*       Sets the limit
****************************************************************************/

void CInitializing::SetLimit(int n)
    {
     c_Progress.SetRange(0, n);
     c_Progress.SetStep(1);
    } // CInitializing::SetLimit

/****************************************************************************
*                            CInitializing::StepIt
* Inputs:
*       const CString & s: Text to set
* Result: void
*       
* Effect: 
*       Steps the progress control
****************************************************************************/

void CInitializing::StepIt(const CString & s)
    {
     c_Reason.SetWindowText(s);
     c_Progress.StepIt();
    } // CInitializing::StepIt

/****************************************************************************
*                            CInitializing::SetPos
* Inputs:
*       int n: Desired position
* Result: void
*       
* Effect: 
*       Sets the scroll position
****************************************************************************/

void CInitializing::SetPos(int n)
    {
     c_Progress.SetPos(n);
    } // CInitializing::SetPos

/****************************************************************************
*                        CInitializing::PostNcDestroy
* Result: void
*       
* Effect: 
*       Deletes the class object
****************************************************************************/

void CInitializing::PostNcDestroy() 
{
        delete this;    
        CDialog::PostNcDestroy();
}
