#if !defined(AFX_ISVALIDCODEPAGE_H__57EC5A0E_3A94_4352_A160_309926F4ECBA__INCLUDED_)
#define AFX_ISVALIDCODEPAGE_H__57EC5A0E_3A94_4352_A160_309926F4ECBA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IsValidCodePage.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "ListCtrlEx.h"
#include "WhatIsItGroupBox.h"
#include "WhatIsThisEdit.h"
#include "CodePages.h"
#include "SpinButtonCtrl7.h"

/////////////////////////////////////////////////////////////////////////////
// CIsValidCodePage dialog

class CIsValidCodePage : public CFunction
{
    DECLARE_DYNCREATE(CIsValidCodePage)
// Construction
public:
        CIsValidCodePage(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CIsValidCodePage)
        enum { IDD = IDD_ISVALIDCODEPAGE };
        CWhatIsItButton c_GetOEMCP;
        CWhatIsItButton c_CP_THREAD_ACP;
        CWhatIsItButton c_CP_OEMCP;
        CWhatIsItButton c_CP_MACCP;
        CWhatIsItButton c_CP_ACP;
        CWhatIsItButton c_GetACP;
        CStatic c_CodePageName;
        CWhatIsItButton c_CP_INSTALLED;
        CWhatIsItButton c_CP_SUPPORTED;
        CWhatIsItButton c_Specific;
        CWhatIsItButton c_Selection;
        CSpinButtonCtrl7 c_SpinCodePage;
        CStatic c_Result;
        CCodePages     c_CodePages;
        CWhatIsItGroupBox       x_dwFlags;
        CWhatIsItButton c_Installed;
        CWhatIsThisEdit c_CodePage;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CIsValidCodePage)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual
      virtual void Refresh();
      virtual void SetFontToControls();
      virtual BOOL IndexOK(CWnd * wnd);
      virtual void Initialize();
protected: // methods
      void UpdateCodePageList();
      void updateControls();
      static BOOL CALLBACK EnumCodePagesProc(LPTSTR codepage);
      static int CALLBACK compare(LPARAM lParam1, LPARAM lParam2, LPARAM);
      void SetCodePageName(int cp);
protected: // data
      static CIsValidCodePage * Self;
protected: // message handlers


        // Generated message map functions
        //{{AFX_MSG(CIsValidCodePage)
        virtual BOOL OnInitDialog();
        afx_msg void OnChangeCodepage();
        afx_msg void OnCpInstalled();
        afx_msg void OnCpSupported();
        afx_msg void OnSelection();
        afx_msg void OnSpecific();
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnItemchangedOutput(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnCpAcp();
	afx_msg void OnCpMaccp();
	afx_msg void OnCpOemcp();
	afx_msg void OnCpThreadAcp();
	afx_msg void OnGetacp();
	afx_msg void OnGetoemcp();
	//}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ISVALIDCODEPAGE_H__57EC5A0E_3A94_4352_A160_309926F4ECBA__INCLUDED_)
