#if !defined(AFX_LCMAPSTRING_H__D20831C5_1FA0_44BB_BB2C_2DD8F94B4565__INCLUDED_)
#define AFX_LCMAPSTRING_H__D20831C5_1FA0_44BB_BB2C_2DD8F94B4565__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LCMapString.h : header file
//
#include "CompareString.h" 
/////////////////////////////////////////////////////////////////////////////
// CLCMapString dialog

class CLCMapString : public CCompareString
{
    DECLARE_DYNCREATE(CLCMapString);
    // Construction
public:
        CLCMapString(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CLCMapString)
        enum { IDD = IDD_COMPARESTRING };
        CWhatIsItGroupBox x_dwMapFlags;
        CWhatIsItButton c_LCMAP_BYTEREV;
        CWhatIsItButton c_LCMAP_SORTKEY;
        CWhatIsItButton c_LCMAP_FULLWIDTH;
        CWhatIsItButton c_LCMAP_HALFWIDTH;
        CWhatIsItButton c_WIDTH_NONE;
        CWhatIsItButton c_LCMAP_HIRAGANA;
        CWhatIsItButton c_LCMAP_KATAKANA;
        CWhatIsItButton c_KANA_NONE;
        CWhatIsItButton c_LCMAP_SIMPLIFIED_CHINESE;
        CWhatIsItButton c_LCMAP_TRADITIONAL_CHINESE;
        CWhatIsItButton c_CHINESE_NONE;
        CWhatIsItButton c_LCMAP_LINGUISTIC_CASING;
        CWhatIsItButton c_LCMAP_UPPERCASE;
        CWhatIsItButton c_LCMAP_LOWERCASE;
        CWhatIsItButton c_CASE_NONE;
        CButton c_WidthBox;
        CButton c_CaseBox;
        CButton c_KanaBox;
        CButton c_ChineseBox;
        //}}AFX_DATA

#define COL_LCMAP (COL_LAST + 1)
// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CLCMapString)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        virtual void PreSubclassWindow();
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual BOOL IndexOK(CWnd * wnd);
        virtual void Refresh();
        virtual void SetFontToControls();
protected: // methods
        void updateControls();
        void Clear();
        void GetFlags(CString & options, DWORD & flags, const CString & or);
protected: // data

protected: // message handlers   

        // Generated message map functions
        //{{AFX_MSG(CLCMapString)
        virtual BOOL OnInitDialog();
        afx_msg void OnLCMapFullWidth();
        afx_msg void OnLCMapHalfWidth();
        afx_msg void OnWidthNone();
        afx_msg void OnLCMapHiragana();
        afx_msg void OnLCMapKataKana();
        afx_msg void OnKanaNone();
        afx_msg void OnLCMapUpperCase();
        afx_msg void OnLCMapLowerCase();
        afx_msg void OnCaseNone();
        afx_msg void OnLCMapLinguisticCasing();
        afx_msg void OnLCMapSimplifiedChinese();
        afx_msg void OnLCMapTraditionalChinese();
        afx_msg void OnChineseNone();
        afx_msg void OnLCMapSortKey();
        afx_msg void OnLCMapByteRev();
        afx_msg void OnClear();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LCMAPSTRING_H__D20831C5_1FA0_44BB_BB2C_2DD8F94B4565__INCLUDED_)
