#if !defined(AFX_LATLONG_H__0D358747_97E4_4002_BF3C_155D0B52D791__INCLUDED_)
#define AFX_LATLONG_H__0D358747_97E4_4002_BF3C_155D0B52D791__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LatLong.h : header file
//
#include "Function.h"
#include "GeoMap.h"
#include "WhatIsThisEdit.h"
#include "HTMLLink.h"
#include "NoNotifyEdit.h"
#include "GEOID.h"
/////////////////////////////////////////////////////////////////////////////
// CLatLong dialog

class CLatLong : public CFunction
{
    DECLARE_DYNCREATE(CLatLong)
// Construction
public:
        CLatLong(CWnd* pParent = NULL);   // standard constructor
        void updateCoordinates();
// Dialog Data
        //{{AFX_DATA(CLatLong)
        enum { IDD = IDD_LATLONG };
        CGEOID       c_GEOID;
        CStatic c_Rect;
        CNoNotifyEdit   c_WindowOrgY;
        CNoNotifyEdit   c_WindowOrgX;
        CNoNotifyEdit   c_WindowExtY;
        CNoNotifyEdit   c_WindowExtX;
        CNoNotifyEdit   c_ViewportOrgY;
        CNoNotifyEdit   c_ViewportOrgX;
        CNoNotifyEdit   c_ViewportExtY;
        CNoNotifyEdit   c_ViewportExtX;
        CStatic x_SetWindowOrg;
        CStatic x_SetViewportExt;
        CStatic x_SetViewportOrg;
        CStatic x_SetWindowExt;
        CHTMLLink       c_MapLink;
        CWhatIsThisEdit c_Longitude;
        CWhatIsThisEdit c_Latitude;
        CStatic c_GMT;
        CGeoMap c_Map;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CLatLong)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
           virtual void Refresh();
           virtual void SetFontToControls();
           virtual void Initialize();
           virtual BOOL IndexOK(CWnd * wnd);
           virtual BOOL QuerySave();
           virtual BOOL Save(const CString & name, UINT mode);
protected:
        static CLatLong * LogWnd;
        static BOOL CALLBACK EnumGeoInfoProc(GEOID geoid);
        // Generated message map functions
        //{{AFX_MSG(CLatLong)
        virtual BOOL OnInitDialog();
        afx_msg void OnChangeLat();
        afx_msg void OnChangeLong();
        afx_msg void OnChangeViewportExtX();
        afx_msg void OnChangeViewportExtY();
        afx_msg void OnChangeViewportOrgX();
        afx_msg void OnChangeViewportOrgY();
        afx_msg void OnChangeWindowExtX();
        afx_msg void OnChangeWindowExtY();
        afx_msg void OnChangeWindowOrgX();
        afx_msg void OnChangeWindowOrgY();
        afx_msg void OnClickGeoid(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnItemchangedGeoid(NMHDR* pNMHDR, LRESULT* pResult);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LATLONG_H__0D358747_97E4_4002_BF3C_155D0B52D791__INCLUDED_)
