#pragma once

class LinkItem {
    public: // Construction/initialization
       LinkItem() { Clear(); }
       LinkItem(CHARRANGE & c1, int n) { range = c1; index = n; }
       void Clear() { range.cpMin = range.cpMax = index = 0; }

    public: // Testing
       BOOL IsMatch(CHARRANGE & r) { return r.cpMin == range.cpMin; }

    public: // I/O
       BOOL Read(CFile & file);
       BOOL Write(CFile & file);

    public:
       //================================================================+
       // These are the variables serialized when the hyperlink is       |
       // written out to the index cache                                 |
       //================================================================+
       CHARRANGE range;                                               // |
       int index; // page index                                       // |
       //================================================================+
};
