#if !defined(AFX_LISTCTRLEX_H__12B9175C_ECAD_4988_8F42_1FD48BCB0993__INCLUDED_)
#define AFX_LISTCTRLEX_H__12B9175C_ECAD_4988_8F42_1FD48BCB0993__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ListCtrlEx.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CListCtrlEx window

class CListCtrlEx : public CListCtrl
{
// Construction
public:
        CListCtrlEx();
        int InsertColumnEx(int n, LPCTSTR caption, UINT flags = DT_CENTER, int width = 0);
        int InsertColumnEx(int n, LPCTSTR caption, UINT flags,             const CString & width);
        int InsertColumnEx(int n, UINT caption,    UINT flags,             int width = 0);
        int InsertColumnEx(int n, UINT caption,    UINT flags,             const CString & width);
        int ItemFromPoint(CPoint pt);
        void SetColumnAlignment(int n, int fmt);
        BOOL GetSubItemRectEx(int item, int subitem, int area, CRect & rect);

// Attributes
public:
        void SetTotal(int value) { total = value; }
        int AddTotal(int delta) { total += delta; return total; }
        int GetTotal() { return total; }
        void SetPeakColumnWidth(int col, int n);
// Operations
public:
        BOOL Save(const CString & filename, UINT mode);
// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CListCtrlEx)
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CListCtrlEx();

        // Generated message map functions
protected:
        int total;
        static void pad(CString & string, int width, UINT fmt);
        //{{AFX_MSG(CListCtrlEx)
                // NOTE - the ClassWizard will add and remove member functions here.
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LISTCTRLEX_H__12B9175C_ECAD_4988_8F42_1FD48BCB0993__INCLUDED_)
