#include "stdafx.h"
#include "MultiSz.h"

/****************************************************************************
*                               ExtractMultiSz
* Inputs:
*       LPTSTR sz: String value of the multi-sz style
* Result: CString
*       A printable represenation of the multisz
****************************************************************************/

CString ExtractMultiSz(LPTSTR str)
   {
    CString result;
#ifdef _UNICODE
#define sep CString(_T("\\x0000"))
#else
#define sep CString(_T("\\x00"))
#endif
    while(lstrlen(str) > 0)
       { /* has something */
        result += str + sep;
        str += lstrlen(str) + 1; // Remember, C already compensages for sizeof(TCHAR)
       } /* has something */
    return result;
   } // ExtractMultiSz
