// ScriptTabDef.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ScriptTabDef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CScriptTabDef, CDialog)

/////////////////////////////////////////////////////////////////////////////
// CScriptTabDef dialog


CScriptTabDef::CScriptTabDef(CWnd* pParent /*=NULL*/)
        : CDialog(CScriptTabDef::IDD, pParent)
{
        //{{AFX_DATA_INIT(CScriptTabDef)
        //}}AFX_DATA_INIT
}


void CScriptTabDef::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CScriptTabDef)
        DDX_Control(pDX, IDC_TAB_REPEAT, c_TabRepeat);
        DDX_Control(pDX, IDC_TAB_MULTIPLE, c_TabMultiple);
        DDX_Control(pDX, IDC_TAB_8, c_Tab8);
        DDX_Control(pDX, IDC_TABS, c_Tabs);
        DDX_Control(pDX, IDC_TAB_REMOVE, c_Remove);
        DDX_Control(pDX, IDC_TAB_ADD, c_Add);
        DDX_Control(pDX, IDC_SPINITABORIGIN, c_SpiniTabOrigin);
        DDX_Control(pDX, IDC_SPINISCALE, c_SpiniScale);
        DDX_Control(pDX, IDC_iTabOrigin, c_iTabOrigin);
        DDX_Control(pDX, IDC_iScale, c_iScale);
        DDX_Control(pDX, IDC_cTabStops, c_cTabStops);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CScriptTabDef, CDialog)
        //{{AFX_MSG_MAP(CScriptTabDef)
        ON_EN_CHANGE(IDC_iScale, OnChangeiScale)
        ON_EN_CHANGE(IDC_iTabOrigin, OnChangeiTabOrigin)
        ON_BN_CLICKED(IDC_TAB_8, OnTab8)
        ON_BN_CLICKED(IDC_TAB_ADD, OnTabAdd)
        ON_BN_CLICKED(IDC_TAB_MULTIPLE, OnTabMultiple)
        ON_BN_CLICKED(IDC_TAB_REMOVE, OnTabRemove)
        ON_BN_CLICKED(IDC_TAB_REPEAT, OnTabRepeat)
        ON_CBN_EDITCHANGE(IDC_TABS, OnEditchangeTabs)
        ON_CBN_SELCHANGE(IDC_TABS, OnSelchangeTabs)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CScriptTabDef message handlers

void CScriptTabDef::OnChangeiScale() 
{
        // TODO: If this is a RICHEDIT control, the control will not
        // send this notification unless you override the CDialog::OnInitDialog()
        // function and call CRichEditCtrl().SetEventMask()
        // with the ENM_CHANGE flag ORed into the mask.
        
        // TODO: Add your control notification handler code here
        
}

void CScriptTabDef::OnChangeiTabOrigin() 
{
        // TODO: If this is a RICHEDIT control, the control will not
        // send this notification unless you override the CDialog::OnInitDialog()
        // function and call CRichEditCtrl().SetEventMask()
        // with the ENM_CHANGE flag ORed into the mask.
        
        // TODO: Add your control notification handler code here
        
}

void CScriptTabDef::OnTab8() 
{
        // TODO: Add your control notification handler code here
        
}

void CScriptTabDef::OnTabAdd() 
{
        // TODO: Add your control notification handler code here
        
}

void CScriptTabDef::OnTabMultiple() 
{
        // TODO: Add your control notification handler code here
        
}

void CScriptTabDef::OnTabRemove() 
{
        // TODO: Add your control notification handler code here
        
}

void CScriptTabDef::OnTabRepeat() 
{
        // TODO: Add your control notification handler code here
        
}

void CScriptTabDef::OnEditchangeTabs() 
   {
    updateControls();
   }

void CScriptTabDef::OnSelchangeTabs() 
{
        // TODO: Add your control notification handler code here
        
}

/****************************************************************************
*                        CScriptTabDef::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CScriptTabDef::updateControls()
    {
     if(c_Tab8.GetCheck() == BST_CHECKED)
        c_cTabStops.SetWindowText(_T("0"));
     else
     if(c_TabRepeat.GetCheck() == BST_CHECKED)
        c_cTabStops.SetWindowText(_T("1"));
     else
     if(c_TabMultiple.GetCheck() == BST_CHECKED)
        { /* multiple */
         CString s;
         s.Format(_T("%d"), c_Tabs.GetCount());
         c_cTabStops.SetWindowText(s);
        } /* multiple */
     else
        ASSERT(FALSE);


     CString s;
     c_Tabs.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();
     c_Add.EnableWindow(!s.IsEmpty());
     int n = c_Tabs.GetCurSel();
     c_Remove.EnableWindow(n != CB_ERR);
     
    } // CScriptTabDef::updateControls

/****************************************************************************
*                         CScriptTabDef::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the dialog
****************************************************************************/

BOOL CScriptTabDef::OnInitDialog() 
   {
    CDialog::OnInitDialog();
        
    ASSERT(ScriptTabDef != NULL);
    
    UINT tabs = IDC_TAB_8;
    int iScale = 4; // default is device coordinates
    int cTabStops = 0;
    int iTabOrigin = 0;

    if(ScriptTabDef != NULL)
       { /* load from input */
        if(ScriptTabDef->cTabStops == 0)
           tabs = IDC_TAB_8;
        else
        if(ScriptTabDef->cTabStops == 1)
           tabs = IDC_TAB_REPEAT;
        else
           tabs = IDC_TAB_MULTIPLE;

        cTabStops = ScriptTabDef->cTabStops;
        iScale = ScriptTabDef->iScale;
        iTabOrigin = ScriptTabDef->iTabOrigin;
        
        if(ScriptTabDef->pTabStops == NULL)
           { /* failed */
            ASSERT(FALSE);
           } /* failed */
        else
           { /* load tabs */
            for(int i = 0; i < cTabStops; i++)
               { /* Scan tabs */
                CString s;
                s.Format(_T("%d"), ScriptTabDef->pTabStops[i]);
                c_Tabs.AddString(s);
               } /* Scan tabs */
           } /* load tabs */
       } /* load from input */

    /****************************************************************
    *  typedef struct tag_SCRIPT_TABDEF {
    *                   int cTabStops;
    *                   int iScale;
    *                   int *pTabStops;
    *                   int iTabOrigin;
    *  } SCRIPT_TABDEF;
    ****************************************************************/
    CheckRadioButton(IDC_TAB_8, IDC_TAB_MULTIPLE, tabs);
    c_SpiniScale.SetPos(iScale);
    // pStabTops already set
    c_SpiniTabOrigin.SetPos(iTabOrigin);

    c_Add.LoadBitmaps(IDB_TAB_ADD);
    c_Remove.LoadBitmaps(IDB_TAB_REMOVE);
    
    return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}
