#if !defined(AFX_SCRIPTTABDEF_H__1A674741_4668_49DD_BC8F_6030F784E4F1__INCLUDED_)
#define AFX_SCRIPTTABDEF_H__1A674741_4668_49DD_BC8F_6030F784E4F1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ScriptTabDef.h : header file
//
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "SpinButtonCtrl7.h"
#include "ImageButton.h"
/////////////////////////////////////////////////////////////////////////////
// CScriptTabDef dialog

class CScriptTabDef : public CDialog
{
    DECLARE_DYNCREATE(CScriptTabDef)
// Construction
public:
        CScriptTabDef(CWnd* pParent = NULL);   // standard constructor
        SCRIPT_TABDEF * ScriptTabDef;
        
// Dialog Data
        //{{AFX_DATA(CScriptTabDef)
        enum { IDD = IDD_SCRIPT_TABDEF };
        CWhatIsItButton c_TabRepeat;
        CWhatIsItButton c_TabMultiple;
        CWhatIsItButton c_Tab8;
        CComboBox       c_Tabs;
        CImageButton c_Remove;
        CImageButton c_Add;
        CSpinButtonCtrl7        c_SpiniTabOrigin;
        CSpinButtonCtrl7        c_SpiniScale;
        CWhatIsThisEdit   c_iTabOrigin;
        CWhatIsThisEdit   c_iScale;
        CWhatIsThisEdit   c_cTabStops;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CScriptTabDef)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        void updateControls();
        // Generated message map functions
        //{{AFX_MSG(CScriptTabDef)
        afx_msg void OnChangeiScale();
        afx_msg void OnChangeiTabOrigin();
        afx_msg void OnTab8();
        afx_msg void OnTabAdd();
        afx_msg void OnTabMultiple();
        afx_msg void OnTabRemove();
        afx_msg void OnTabRepeat();
        afx_msg void OnEditchangeTabs();
        afx_msg void OnSelchangeTabs();
        virtual BOOL OnInitDialog();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCRIPTTABDEF_H__1A674741_4668_49DD_BC8F_6030F784E4F1__INCLUDED_)
