#if !defined(AFX_SHOWGLYPH_H__7296F16C_42B2_4266_B9CE_49F63D223224__INCLUDED_)
#define AFX_SHOWGLYPH_H__7296F16C_42B2_4266_B9CE_49F63D223224__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ShowGlyph.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CShowGlyph window

class CShowGlyph : public CWnd
{
    DECLARE_DYNAMIC(CShowGlyph)
// Construction
public:
        CShowGlyph();
        BOOL Create(int x, int y, CWnd * parent);

// Attributes
public:
        void SetText(LPCTSTR s);
        void SetTextAlign(UINT ta);
        typedef enum { None, Char, Text} ShowStyle;
        void SetStyle(ShowStyle style, CFont * f);
// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CShowGlyph)
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CShowGlyph();

        // Generated message map functions
protected:
        void ReplaceFont(LOGFONT * f);
        ShowStyle CurrentStyle;
        afx_msg LRESULT OnSetFont(WPARAM, LPARAM);
        afx_msg LRESULT OnGetFont(WPARAM, LPARAM);
        HFONT font;
        CString text;
        //{{AFX_MSG(CShowGlyph)
        afx_msg void OnPaint();
        afx_msg BOOL OnEraseBkgnd(CDC* pDC);
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SHOWGLYPH_H__7296F16C_42B2_4266_B9CE_49F63D223224__INCLUDED_)
