#if !defined(AFX_TIMEFORMATS_H__ACEC2967_B4E3_46F8_8ED7_3C117CE115F8__INCLUDED_)
#define AFX_TIMEFORMATS_H__ACEC2967_B4E3_46F8_8ED7_3C117CE115F8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TimeFormats.h : header file
//
#include "CodeTemplate.h"
#include "Function.h"
#include "WhatIsItButton.h"
#include "ListCtrlEx.h"
#include "WhatIsThisEdit.h"

/////////////////////////////////////////////////////////////////////////////
// CTimeFormats dialog

class CTimeFormats : public CFunction
{
    DECLARE_DYNCREATE(CTimeFormats)
// Construction
public:
        CTimeFormats(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CTimeFormats)
        enum { IDD = IDD_TIMEFORMATS };
        CStatic c_IgnoreCaption;
        CWhatIsItButton c_SpareRadio;
         CWhatIsThisEdit   c_CallbackName;
         CListCtrlEx c_Output;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CTimeFormats)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual BOOL IndexOK(CWnd * wnd);
protected: // data
        static CTimeFormats * LogWnd;
protected: // methods
        static BOOL CALLBACK EnumTimeFormatsProc(LPTSTR time);
        void UpdateCode();
        void ShowTimeFormats();
        // Generated message map functions
        //{{AFX_MSG(CTimeFormats)
        afx_msg void OnChangeCallbackName();
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TIMEFORMATS_H__ACEC2967_B4E3_46F8_8ED7_3C117CE115F8__INCLUDED_)
