#if !defined(AFX_VERTICALHEADER_H__BD111D6A_BFF4_4AED_9551_A266AC2B9E79__INCLUDED_)
#define AFX_VERTICALHEADER_H__BD111D6A_BFF4_4AED_9551_A266AC2B9E79__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// VerticalHeader.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CVerticalHeader window

class CVerticalHeader : public CHeaderCtrl
{
// Construction
public:
        CVerticalHeader();

// Attributes
public:

// Operations
public:
        void SetTextAlign(UINT col, UINT flags);
        // Options
        // Horizontal
        //      DT_LEFT       0x00000000
        //      DT_CENTER     0x00000001
        //      DT_RIGHT      0x00000002
        // Vertical
        //      DT_TOP        0x00000000
        //      DT_VCENTER    0x00000004
        //      DT_BOTTOM     0x00000008
        // Orientation
#define         DT_0          0x00010000
#define         DT_90         0x00020000
#define         DT_180        0x00030000
#define         DT_270        0x00040000
#define         DT_ROTATEMASK 0x000F0000 // rotation mask
#define         DT_STYLEMASK  0x0000000F
#define         DT_HORZ       0x00000003 // horizontal styles
#define         DT_VERT       0x0000000C // horizontal styles
// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CVerticalHeader)
        protected:
        virtual void PreSubclassWindow();
        virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CVerticalHeader();
        void GetItemText(UINT col, CString & s);
        LPARAM GetItemData(UINT col);
        // Generated message map functions
protected:
        CFont font0;  // font for horizontal drawing
        CFont font90;  // font for vertical drawing
        CFont font180; // font for inverse horizontal drawing
        CFont font270; // font for inverse vertical drawing
        CFont fontfake; // fake font to set height of control
        //{{AFX_MSG(CVerticalHeader)
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VERTICALHEADER_H__BD111D6A_BFF4_4AED_9551_A266AC2B9E79__INCLUDED_)
