// Arrow.cpp : implementation file
//

#include "stdafx.h"
#include "Arrow.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CArrow

CArrow::CArrow()
  {
   direction = DrawArrow::ARROW_NONE;
  }

CArrow::~CArrow()
{
}


BEGIN_MESSAGE_MAP(CArrow, CStatic)
        //{{AFX_MSG_MAP(CArrow)
        ON_WM_PAINT()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArrow message handlers

void CArrow::OnPaint() 
   {
    CPaintDC dc(this); // device context for painting
        
    CRect r;
    GetClientRect(&r);

    CRect fill = r;
    fill.InflateRect(1, 1);
    dc.FillSolidRect(&fill, ::GetSysColor(COLOR_3DFACE));

    DrawArrow::Draw(dc, fill, direction);
}

/****************************************************************************
*                            CArrow::SetDirection
* Inputs:
*       DrawArrow::Direction dir: Direction to set
* Result: void
*       
* Effect: 
*       Sets the direction
****************************************************************************/

void CArrow::SetDirection(DrawArrow::Direction dir)
    {
     if(direction == dir)
        return; // ignore it if already set
     direction = dir;
     if(GetSafeHwnd() != NULL)
        Invalidate();
    } // CArrow::SetDirection
