#if !defined(AFX_CODEPAGECOMBO_H__2E333B04_4BCE_4D2B_9AE2_51D1C0B3EC15__INCLUDED_)
#define AFX_CODEPAGECOMBO_H__2E333B04_4BCE_4D2B_9AE2_51D1C0B3EC15__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CodePageCombo.h : header file
//
#include "IDCombo.h"
/////////////////////////////////////////////////////////////////////////////
// CCodePageCombo window

class CCodePageCombo : public CIDCombo
{
// Construction
public:
        CCodePageCombo();
        int SetItemData(int n, LPARAM lParam) { ASSERT(FALSE); return CB_ERR; }
        int SetItemDataPtr(int n, void * lParam) { ASSERT(FALSE); return CB_ERR; }
        LPARAM GetItemData(int n) { ASSERT(FALSE); return 0; }
        void * GetItemDataPtr(int n) { ASSERT(FALSE); return NULL; }
// Attributes
public:
        CString GetCodePageName(int n) { Info * info =  (Info *)CIDCombo::GetItemDataPtr(n);
                                         if(info != NULL)
                                            return info->text;
                                         else
                                            return _T("");
                                       }
        UINT GetCodePage(int n) { Info * info = (Info *)CIDCombo::GetItemDataPtr(n);
                                  if(info != NULL)
                                     return info->codepage;
                                  else
                                     return 0;
                                }
// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CCodePageCombo)
        public:
        virtual int CompareItem(LPCOMPAREITEMSTRUCT lpCompareItemStruct);
        virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
        virtual void DeleteItem(LPDELETEITEMSTRUCT lpDeleteItemStruct);
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CCodePageCombo();
        int AddString(LPCTSTR s, UINT id);
        int SupersedeString(LPCTSTR s, UINT id);
        int Select(UINT cp);

        // Generated message map functions
protected:
        class Info {
            public:
               Info(const CString & s, UINT id) { text = s; codepage = id; }
            public:
               CString text;
               UINT codepage;
        };
        //{{AFX_MSG(CCodePageCombo)
                // NOTE - the ClassWizard will add and remove member functions here.
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CODEPAGECOMBO_H__2E333B04_4BCE_4D2B_9AE2_51D1C0B3EC15__INCLUDED_)
