#if !defined(AFX_CODEPAGEINFO_H__61045ADE_91C2_4EFB_A2CA_F0F85B690531__INCLUDED_)
#define AFX_CODEPAGEINFO_H__61045ADE_91C2_4EFB_A2CA_F0F85B690531__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// CodePageInfo.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CCodePageInfo dialog
#include "Function.h"
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "ListCtrlEx.h"
#include "CodePages.h"

class CCodePageInfo : public CFunction
{
    DECLARE_DYNCREATE(CCodePageInfo)
// Construction
public:
        CCodePageInfo(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CCodePageInfo)
        enum { IDD = IDD_CODEPAGEINFO };
        CWhatIsItButton c_CP_THREAD_ACP;
        CWhatIsItButton c_CP_OEMCP;
        CWhatIsItButton c_CP_MACCP;
        CWhatIsItButton c_CP_ACP;
        CStatic c_Result;
        CStatic x_MaxCharSize;
        CStatic x_DefaultChar;
        CWhatIsItButton c_GetOEMCP;
        CWhatIsItButton c_CP_SUPPORTED;
        CWhatIsItButton c_CP_INSTALLED;
        CWhatIsItButton c_SourceCodePage;
        CWhatIsItButton c_GetACP;
        CStatic x_UnicodeDefaultChar;
        CWhatIsThisEdit c_UnicodeDefaultChar;
        CStatic x_LeadByte;
        CWhatIsThisEdit c_DefaultChar;
        CWhatIsThisEdit c_MaxCharSize;
        CWhatIsThisEdit c_LeadByte;
        CStatic x_CodePageName;
        CWhatIsThisEdit c_CodePageName;
        CStatic x_CodePage;
        CWhatIsThisEdit c_CodePage;
        CButton c_API;
        CWhatIsItButton c_GetCPInfoEx;
        CWhatIsItButton c_GetCPInfo;
        CCodePages     c_CodePages;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CCodePageInfo)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual void OnSetActive();
        virtual BOOL QuerySave();
        virtual BOOL Save(const CString & filename, UINT mode);
protected: // methods
        void updateControls();
        void UpdateCodePageList();
        void EnableOutputDisplay(BOOL mode);
        static BOOL CALLBACK EnumCodePagesProc(LPTSTR codepage);
        static int CALLBACK compare(LPARAM lParam1, LPARAM lParam2, LPARAM);
protected: // data
        static CCodePageInfo * Self;
protected: // message handling
        // Generated message map functions
        //{{AFX_MSG(CCodePageInfo)
        afx_msg void OnGetcpinfo();
        afx_msg void OnGetcpinfoex();
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnGetacp();
        afx_msg void OnLocale();
        afx_msg void OnSourceCodepage();
        afx_msg void OnCpInstalled();
        afx_msg void OnCpSupported();
        afx_msg void OnOdstatechangedCodepages(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnClickCodepages(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnGetoemcp();
        afx_msg void OnCpThreadAcp();
        afx_msg void OnCpOemcp();
        afx_msg void OnCpMaccp();
        afx_msg void OnCpAcp();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CODEPAGEINFO_H__61045ADE_91C2_4EFB_A2CA_F0F85B690531__INCLUDED_)
