#if !defined(AFX_ENUMSYSTEMCODEPAGES_H__8A5A316B_B4F9_4494_99B5_4E9FBE2DCCA3__INCLUDED_)
#define AFX_ENUMSYSTEMCODEPAGES_H__8A5A316B_B4F9_4494_99B5_4E9FBE2DCCA3__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EnumSystemCodePages.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "ListCtrlEx.h"
#include "WhatIsThisEdit.h"
#include "WhatIsItGroupBox.h"

/////////////////////////////////////////////////////////////////////////////
// CEnumSystemCodePages dialog

class CEnumSystemCodePages : public CFunction
{
    DECLARE_DYNCREATE(CEnumSystemCodePages)
// Construction
public:
        CEnumSystemCodePages(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CEnumSystemCodePages)
        enum { IDD = IDD_ENUM_SYSTEM_CODE_PAGES };
        CWhatIsItGroupBox       x_dwFlags;
        CListCtrlEx       c_Output;
        CWhatIsItButton c_CP_SUPPORTED;
        CWhatIsItButton c_CP_INSTALLED;
        CWhatIsThisEdit   c_CallbackName;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CEnumSystemCodePages)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
        protected: // virtual methods
           virtual void SetFontToControls();
           virtual void Refresh();
           virtual void Initialize();
           virtual BOOL QuerySave();
           virtual BOOL Save(const CString & name, UINT mode);
        protected: // data
           static CEnumSystemCodePages * LogWnd;
           static BOOL CALLBACK EnumCodePagesProc(LPTSTR data);
        protected: // methods
           static int CALLBACK compare(LPARAM, LPARAM, LPARAM);
        protected: // Message handlers
           afx_msg LRESULT OnLogData(WPARAM, LPARAM);

        // Generated message map functions
        //{{AFX_MSG(CEnumSystemCodePages)
        afx_msg void OnChangeCallbackName();
        afx_msg void OnCpInstalled();
        afx_msg void OnCpSupported();
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ENUMSYSTEMCODEPAGES_H__8A5A316B_B4F9_4494_99B5_4E9FBE2DCCA3__INCLUDED_)
