#if !defined(AFX_FONTMAP_H__1651D1EB_4B52_409C_8D8D_1CC338FBC42D__INCLUDED_)
#define AFX_FONTMAP_H__1651D1EB_4B52_409C_8D8D_1CC338FBC42D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FontMap.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFontMap dialog
#include "idcombo.h"
#include "FontMapData.h"
#include "SpinButtonCtrl7.h"

class CFontMap : public CDialog
{
// Construction
public:
        CFontMap(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CFontMap)
        enum { IDD = IDD_FONTMAP };
        CButton c_LTR_DEFAULT;
        CButton c_LTR;
        CButton c_BrowseFont;
        CButton c_RTL;
        CStatic c_HexLCID;
        CButton c_Remove;
        CButton c_Add;
        CButton c_OK;
        CSpinButtonCtrl7 c_SpinSize;
        CEdit   c_Size;
        CIDCombo        c_LCID;
        CEdit   c_FontName;
        CFontMapData       c_FontMap;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CFontMap)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        void updateControls();
        RegFontInfo::Direction ControlsToDirection();
        void DirectionToControls(RegFontInfo::Direction);
        // Generated message map functions
        //{{AFX_MSG(CFontMap)
        virtual BOOL OnInitDialog();
        afx_msg void OnBrowsefont();
        afx_msg void OnChangeLcid();
        afx_msg void OnChangeFontname();
        afx_msg void OnChangeSize();
        afx_msg void OnSelendokLcid();
        afx_msg void OnAdd();
        afx_msg void OnRemove();
        afx_msg void OnDblclkFontmap(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnRtlDefault();
        afx_msg void OnRtl();
        afx_msg void OnLtr();
        virtual void OnOK();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FONTMAP_H__1651D1EB_4B52_409C_8D8D_1CC338FBC42D__INCLUDED_)
