#if !defined(AFX_FONTMAPDATA_H__28966D97_5877_448E_8CF8_103EE1C21923__INCLUDED_)
#define AFX_FONTMAPDATA_H__28966D97_5877_448E_8CF8_103EE1C21923__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FontMapData.h : header file
//

#include "RegFontInfo.h"
/////////////////////////////////////////////////////////////////////////////
// CFontMapData window

class CFontMapData : public CListCtrl
{
// Construction
public:
        CFontMapData();

// Attributes
public:
        void SetColumn(int col, const CString & text, const CString & widest=CString(_T("")));
        void CFontMapData::SetColumn(int col, const CString & text, int width);
        int SetFontInfo(const RegFontInfo & info);
        BOOL QueryFontInfo(LCID lcid, RegFontInfo & info);
        BOOL QueryFontInfo(const CString & lcid, RegFontInfo & info);
        RegFontInfo * GetFontInfo(int n);
        int AddFontInfo(RegFontInfo *);
        RegFontInfo * FindFontInfo(LCID lcid);
// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CFontMapData)
        protected:
        virtual void PreSubclassWindow();
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CFontMapData();

        // Generated message map functions
protected:
        int LocateFontInfo(LCID lcid);
        void Initialize();
        //{{AFX_MSG(CFontMapData)
        afx_msg void OnDeleteitem(NMHDR* pNMHDR, LRESULT* pResult);
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FONTMAPDATA_H__28966D97_5877_448E_8CF8_103EE1C21923__INCLUDED_)
