#if !defined(AFX_GEOMAP_H__AE62B920_D85F_4C2D_8E78_5AF49B9C049F__INCLUDED_)
#define AFX_GEOMAP_H__AE62B920_D85F_4C2D_8E78_5AF49B9C049F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GeoMap.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CGeoMap window

class CGeoMap : public CStatic
{
// Construction
public:
        CGeoMap();

// Attributes
public:
        void SetLatitude(double d);
        void SetLongitude(double d);
        void SetCoordinates(double lat, double lon);
        void ClearCoordinates();
        void SetColor(COLORREF c, BOOL force=TRUE);
        void SetMapRect(const CRect & r);
        void SetROP2(UINT rop, BOOL force=TRUE);
// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGeoMap)
        protected:
        virtual void PreSubclassWindow();
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CGeoMap();
public:
       CSize m_ViewportExt;
       CPoint m_ViewportOrg;
       CSize m_WindowExt;
       CPoint m_WindowOrg;
        // Generated message map functions
protected: // data
        CStatic c_Overlay;
        double Latitude;
        double Longitude;
        BOOL CoordinatesSet;
        CRect MapRect;
        CRect Vertical;
        CRect Horizontal;

        UINT rop2;
        BOOL rop2Force;

        COLORREF color;
        BOOL colorForce;
protected: // methods
        void Redraw();

        //{{AFX_MSG(CGeoMap)
        afx_msg void OnPaint();
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GEOMAP_H__AE62B920_D85F_4C2D_8E78_5AF49B9C049F__INCLUDED_)
