#if !defined(AFX_GETCURRENCYFORMAT_H__5271C375_9D98_4119_8642_2DD19D6ED81B__INCLUDED_)
#define AFX_GETCURRENCYFORMAT_H__5271C375_9D98_4119_8642_2DD19D6ED81B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GetCurrencyFormat.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "SpinButtonCtrl7.h" 
/////////////////////////////////////////////////////////////////////////////
// CGetCurrencyFormat dialog

class CGetCurrencyFormat : public CFunction       
{
    DECLARE_DYNCREATE(CGetCurrencyFormat)
// Construction
public:
        CGetCurrencyFormat(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CGetCurrencyFormat)
        enum { IDD = IDD_GETCURRENCYFORMAT };
        CWhatIsItButton c_IndicGrouping;
        CWhatIsThisEdit c_Translated;
        CWhatIsItButton c_ShowDigitTranslation;
        CWhatIsThisEdit c_LocalizedDigits;
        CWhatIsThisEdit c_ValueName;
        CWhatIsThisEdit c_CURRENCYFMTName;
        CStatic x_LeadingZero;
        CStatic x_CurrencySymbol;
        CStatic x_PositiveOrder;
        CStatic x_NegativeOrder;
        CStatic x_ThousandSep;
        CStatic x_DecimalSep;
        CWhatIsItButton c_CustomCurrencySymbol;
        CWhatIsItButton c_CustomPositiveOrder;
        CWhatIsItButton c_CustomNegativeOrder;
        CWhatIsItButton c_CustomThousandSep;
        CWhatIsItButton c_CustomDecimalSep;
        CStatic x_Grouping;
        CWhatIsItButton c_CustomLeadingZero;
        CWhatIsItButton c_CustomNumDigits;
        CWhatIsItButton c_DefaultToLocale;
        CStatic x_NumDigits;
        CWhatIsItButton c_UseFormat;
        CButton c_CURRENCYFMT;
        CSpinButtonCtrl7 c_SpinPositiveOrder;
        CSpinButtonCtrl7 c_SpinNegativeOrder;
        CSpinButtonCtrl7 c_SpinNumDigits;
        CWhatIsThisEdit c_Result;
        CWhatIsThisEdit c_NumDigits;
        CWhatIsThisEdit c_PositiveOrder;
        CWhatIsThisEdit c_CurrencySymbol;
        CWhatIsThisEdit c_DecimalSep;
        CWhatIsThisEdit c_ThousandSep;
        CWhatIsThisEdit c_NegativeOrder;
        CWhatIsThisEdit c_Grouping;
        CWhatIsItButton c_LeadingZero;
        CWhatIsItButton c_LOCALE_ICURRENCY;
        CWhatIsItButton c_LOCALE_IDIGITS;
        CWhatIsItButton c_LOCALE_ILZERO;
        CWhatIsItButton c_LOCALE_INEGCURR;
        CWhatIsItButton c_LOCALE_SCURRENCY;
        CWhatIsItButton c_Add;
        CStatic c_ShowPositiveOrder;
        CStatic c_ShowNegativeOrder;
        CSpinButtonCtrl7 c_SpinGrouping;
        CComboBox       c_Samples;
        CWhatIsItButton c_Remove;
        CWhatIsItButton c_LOCALE_STHOUSAND;
        CWhatIsItButton c_LOCALE_SDECIMAL;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGetCurrencyFormat)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual void Initialize();
        virtual void OnSetActive();
        virtual BOOL IndexOK(CWnd * wnd);
protected: // methods
        void updateControls();
        void FormatSample(CString & showOrder, CString sdecimal_data, CString scurrency_data);
        void InitializeVariableNames();
protected: // data
        CURRENCYFMT CurrencyFormat;
protected: // Message handlers
        // Generated message map functions
        //{{AFX_MSG(CGetCurrencyFormat)
        virtual BOOL OnInitDialog();
        afx_msg void OnAdd();
        afx_msg void OnRemove();
        afx_msg void OnCurrencyFormatNull();
        afx_msg void OnCustomFmt();
        afx_msg void OnEditchangeSamples();
        afx_msg void OnSelchangeSamples();
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnLocaleIdigits();
        afx_msg void OnLocaleIlzero();
        afx_msg void OnLeadingzero();
        afx_msg void OnChangeGrouping();
        afx_msg void OnCustomNumdigits();
        afx_msg void OnCustomLeadingzero();
        afx_msg void OnCustomNegativeorder();
        afx_msg void OnCustomPositiveorder();
        afx_msg void OnCustomThousandsep();
        afx_msg void OnLocaleIcurrency();
        afx_msg void OnLocaleInegcurr();
        afx_msg void OnLocaleScurrency();
        afx_msg void OnLocaleSdecimal();
        afx_msg void OnLocaleSthousand();
        afx_msg void OnChangeLpcurrencysymbol();
        afx_msg void OnChangeLpdecimalsep();
        afx_msg void OnChangeLpthousandsep();
        afx_msg void OnChangeNegativeorder();
        afx_msg void OnChangeNumdigits();
        afx_msg void OnChangePositiveorder();
        afx_msg void OnCustomCurrencysymbol();
        afx_msg void OnCustomDecimalsep();
        afx_msg void OnChangeCurrencyfmtName();
        afx_msg void OnChangeValueName();
        afx_msg void OnShowDigitTranslation();
        afx_msg void OnSelendokSamples();
        afx_msg void OnIndicGrouping();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GETCURRENCYFORMAT_H__5271C375_9D98_4119_8642_2DD19D6ED81B__INCLUDED_)
