#if !defined(AFX_GETDATEFORMAT_H__A7579108_D498_4EC8_8F9C_4A25CD5FEE2A__INCLUDED_)
#define AFX_GETDATEFORMAT_H__A7579108_D498_4EC8_8F9C_4A25CD5FEE2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GetDateFormat.h : header file
//
#include "Function.h"
#include "WhatIsThisEdit.h"
#include "WhatIsItButton.h"
#include "SpinButtonCtrl7.h"
/////////////////////////////////////////////////////////////////////////////
// CGetDateFormat dialog

class CGetDateFormat : public CFunction
{
    DECLARE_DYNCREATE(CGetDateFormat)
// Construction
public:
        CGetDateFormat(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CGetDateFormat)
        enum { IDD = IDD_GETDATEFORMAT };
        CWhatIsItButton c_Space;
        CWhatIsItButton c_DateDefaultDirection;
        CButton c_CustomBox;
        CButton c_OtherBox;
        CButton c_FormattingBox;
        CButton c_FormatDateBox;
        CButton c_dwFlagsBox;
        CButton c_DirectionBox;
        CButton c_YearBox;
        CButton c_MonthBox;
        CButton c_DayOfMonthBox;
        CButton c_DayOfWeekBox;
        CButton c_Punctuation;
        CStatic x_Format;
        CButton c_FormatBox;
        CStatic x_SystemTimeName;
        CWhatIsThisEdit c_SystemTimeName;
        CWhatIsItButton c_UseExplicitFormatting;
        CWhatIsItButton c_UseDefaultFormatting;
        CWhatIsItButton c_EnumDateFormats;
        CWhatIsItButton c_Slash;
        CWhatIsItButton c_Quote;
        CWhatIsItButton c_Hyphen;
        CWhatIsItButton c_Dot;
        CWhatIsItButton c_Colon;
        CWhatIsItButton c_Comma;
        CListBox        c_Formats;
        CWhatIsItButton c_DateRTLReading;
        CWhatIsItButton c_DateLTRReading;
        CWhatIsItButton c_DateYearMonth;
        CWhatIsItButton c_DateLongDate;
        CWhatIsItButton c_CurrentSystemTime;
        CWhatIsItButton c_SpecificTime;
        CWhatIsThisEdit c_Year;
        CSpinButtonCtrl7 c_SpinSecond;
        CSpinButtonCtrl7 c_SpinMinute;
        CSpinButtonCtrl7 c_SpinMilliseconds;
        CSpinButtonCtrl7 c_SpinHour;
        CSpinButtonCtrl7 c_SpinDayOfWeek;
        CSpinButtonCtrl7 c_SpinDay;
        CWhatIsThisEdit c_Second;
        CWhatIsThisEdit c_Month;
        CWhatIsThisEdit c_Minute;
        CWhatIsThisEdit c_Milliseconds;
        CWhatIsThisEdit c_Hour;
        CWhatIsThisEdit c_DayOfWeek;
        CStatic x_Day;
        CWhatIsItButton c_yyyy;
        CWhatIsItButton c_yy;
        CStatic x_Year;
        CWhatIsItButton c_y;
        CStatic c_UseCPACP;
        CButton c_SYSTEMTIME;
        CSpinButtonCtrl7 c_SpinYear;
        CSpinButtonCtrl7 c_SpinMonth;
        CStatic x_Second;
        CWhatIsThisEdit c_Result;
        CWhatIsItButton c_Remove;
        CStatic c_NoUserOverride;
        CStatic x_Month;
        CWhatIsItButton c_MMMM;
        CWhatIsItButton c_MMM;
        CWhatIsItButton c_MM;
        CStatic x_Minute;
        CStatic x_Milliseconds;
        CWhatIsItButton c_M;
        CStatic x_Hour;
        CWhatIsItButton c_gg;
        CWhatIsItButton c_GetNow;
        CWhatIsThisEdit       c_Format;
        CWhatIsItButton c_dddd;
        CWhatIsItButton c_ddd;
        CWhatIsItButton c_dd;
        CStatic x_DayOfWeek;
        CStatic c_Day;
        CWhatIsItButton c_DateUseAltCalendar;
        CWhatIsItButton c_DateShortDate;
        CWhatIsItButton c_d;
        CWhatIsItButton c_Add;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGetDateFormat)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void Initialize();
        virtual void SetFontToControls();
        virtual BOOL IndexOK(CWnd * wnd);
protected: // methods        
        void updateControls();
        void Insert(const CString & text);
        void updateSpecificTime();
protected: // static objects
        static CGetDateFormat * LogWnd;
        static BOOL CALLBACK EnumDateFormatsProc(LPTSTR fmt);
protected: // data
        SYSTEMTIME specificTime;
protected: // Message handlers
        // Generated message map functions
        //{{AFX_MSG(CGetDateFormat)
        virtual BOOL OnInitDialog();
        afx_msg void OnAdd();
        afx_msg void OnCurrentSystemTime();
        afx_msg void OnD();
        afx_msg void OnDateLongdate();
        afx_msg void OnDateLtrreading();
        afx_msg void OnDateRtlreading();
        afx_msg void OnDateShortdate();
        afx_msg void OnDateUseAltCalendar();
        afx_msg void OnDateYearmonth();
        afx_msg void OnChangeDay();
        afx_msg void OnChangeDayofweek();
        afx_msg void OnDd();
        afx_msg void OnDdd();
        afx_msg void OnDddd();
        afx_msg void OnEditchangeFormat();
        afx_msg void OnGetnow();
        afx_msg void OnGg();
        afx_msg void OnChangeHour();
        afx_msg void OnM();
        afx_msg void OnChangeMilliseconds();
        afx_msg void OnChangeMinute();
        afx_msg void OnMm();
        afx_msg void OnMmm();
        afx_msg void OnMmmm();
        afx_msg void OnChangeMonth();
        afx_msg void OnRemove();
        afx_msg void OnChangeSecond();
        afx_msg void OnSpecificTime();
        afx_msg void OnY();
        afx_msg void OnChangeYear();
        afx_msg void OnYy();
        afx_msg void OnYyyy();
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnSelchangeFormats();
        afx_msg void OnDblclkFormats();
        afx_msg void OnChangeFormat();
        afx_msg void OnColon();
        afx_msg void OnComma();
        afx_msg void OnDot();
        afx_msg void OnHyphen();
        afx_msg void OnQuote();
        afx_msg void OnSlash();
        afx_msg void OnEnumdateformats();
        afx_msg void OnDefaultFormatting();
        afx_msg void OnUseExplicitFormatting();
        afx_msg void OnChangeSystemtimeName();
        afx_msg void OnSpace();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GETDATEFORMAT_H__A7579108_D498_4EC8_8F9C_4A25CD5FEE2A__INCLUDED_)
