#if !defined(AFX_GETGEOINFO_H__4AFEC8F1_16F6_467B_A6B9_DEC8011FC2C7__INCLUDED_)
#define AFX_GETGEOINFO_H__4AFEC8F1_16F6_467B_A6B9_DEC8011FC2C7__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GetGeoInfo.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "GEOID.h"

/////////////////////////////////////////////////////////////////////////////
// CGetGeoInfo dialog

class CGetGeoInfo : public CFunction
{
    DECLARE_DYNCREATE(CGetGeoInfo)
// Construction
public:
        CGetGeoInfo(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CGetGeoInfo)
        enum { IDD = IDD_GET_GEO_INFO };
        CWhatIsItButton c_GEO_TIMEZONES;
        CWhatIsItButton c_GEO_RFC1766;
        CWhatIsItButton c_GEO_OFFICIALNAME;
        CWhatIsItButton c_GEO_OFFICIALLANGUAGES;
        CWhatIsItButton c_GEO_LONGITUDE;
        CWhatIsItButton c_GEO_LCID;
        CWhatIsItButton c_GEO_LATITUDE;
        CWhatIsItButton c_GEO_ISO3;
        CWhatIsItButton c_GEO_ISO2;
        CWhatIsItButton c_GEO_NATION;
        CStatic c_Result;
        CStatic c_LangID;
        CGEOID       c_GEOID;
        //}}AFX_DATA

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGetGeoInfo)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Initialize();
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual BOOL IndexOK(CWnd * wnd);
protected: // methods
        static BOOL CALLBACK EnumGeoInfoProc(GEOID geoid);
        GEOID ControlsToGEOTYPE(UINT id);
protected: // data
        static CGetGeoInfo * LogWnd;
        UINT SelectedGeoType;
protected: // message handlers
        afx_msg void OnGeoType(UINT id);
        // Generated message map functions
        //{{AFX_MSG(CGetGeoInfo)
        virtual BOOL OnInitDialog();
        afx_msg void OnClickGeoid(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnItemchangedGeoid(NMHDR* pNMHDR, LRESULT* pResult);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GETGEOINFO_H__4AFEC8F1_16F6_467B_A6B9_DEC8011FC2C7__INCLUDED_)
