#if !defined(AFX_GETNUMBERFORMAT_H__5271C375_9D98_4119_8642_2DD19D6ED81B__INCLUDED_)
#define AFX_GETNUMBERFORMAT_H__5271C375_9D98_4119_8642_2DD19D6ED81B__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GetNumberFormat.h : header file
//
#include "Function.h"
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
#include "SpinButtonCtrl7.h"
/////////////////////////////////////////////////////////////////////////////
// CGetNumberFormat dialog

class CGetNumberFormat : public CFunction       
{
    DECLARE_DYNCREATE(CGetNumberFormat)
// Construction
public:
        CGetNumberFormat(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CGetNumberFormat)
        enum { IDD = IDD_GETNUMBERFORMAT };
        CWhatIsItButton c_IndicGrouping;
        CWhatIsThisEdit c_Translated;
        CWhatIsItButton c_ShowDigitTranslation;
        CWhatIsThisEdit c_LocalizedDigits;
        CWhatIsThisEdit c_ValueName;
        CWhatIsThisEdit c_NUMBERFMTName;
        CStatic x_LeadingZero;
        CStatic x_NegativeOrder;
        CStatic x_ThousandSep;
        CStatic x_DecimalSep;
        CWhatIsItButton c_CustomNegativeOrder;
        CWhatIsItButton c_CustomThousandSep;
        CWhatIsItButton c_CustomDecimalSep;
        CStatic x_Grouping;
        CWhatIsItButton c_CustomLeadingZero;
        CWhatIsItButton c_CustomNumDigits;
        CWhatIsItButton c_DefaultToLocale;
        CStatic x_NumDigits;
        CWhatIsItButton c_UseFormat;
        CButton c_NUMBERFMT;
        CSpinButtonCtrl7 c_SpinNegativeOrder;
        CSpinButtonCtrl7 c_SpinNumDigits;
        CWhatIsThisEdit c_Result;
        CWhatIsThisEdit c_NumDigits;
        CWhatIsThisEdit c_DecimalSep;
        CWhatIsThisEdit c_ThousandSep;
        CWhatIsThisEdit c_NegativeOrder;
        CWhatIsThisEdit c_Grouping;
        CWhatIsItButton c_LeadingZero;
        CWhatIsItButton c_LOCALE_INUMBER;
        CWhatIsItButton c_LOCALE_IDIGITS;
        CWhatIsItButton c_LOCALE_ILZERO;
        CWhatIsItButton c_LOCALE_INEGNUMBER;
        CWhatIsItButton c_LOCALE_SNUMBER;
        CWhatIsItButton c_Add;
        CStatic c_ShowNegativeOrder;
        CSpinButtonCtrl7 c_SpinGrouping;
        CComboBox       c_Samples;
        CWhatIsItButton c_Remove;
        CWhatIsItButton c_LOCALE_STHOUSAND;
        CWhatIsItButton c_LOCALE_SDECIMAL;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGetNumberFormat)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual void Initialize();
        virtual void OnSetActive();
        virtual BOOL IndexOK(CWnd * wnd);
protected: // methods
        void updateControls();
        void FormatSample(CString & showOrder, CString sdecimal_data);
        void InitializeVariableNames();
protected: // data
        NUMBERFMT NumberFormat;
protected: // Message handlers
        // Generated message map functions
        //{{AFX_MSG(CGetNumberFormat)
        virtual BOOL OnInitDialog();
        afx_msg void OnAdd();
        afx_msg void OnRemove();
        afx_msg void OnNumberFormatNull();
        afx_msg void OnCustomFmt();
        afx_msg void OnEditchangeSamples();
        afx_msg void OnSelchangeSamples();
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnLocaleIdigits();
        afx_msg void OnLocaleIlzero();
        afx_msg void OnLeadingzero();
        afx_msg void OnChangeGrouping();
        afx_msg void OnCustomNumdigits();
        afx_msg void OnCustomLeadingzero();
        afx_msg void OnCustomNegativeorder();
        afx_msg void OnCustomThousandsep();
        afx_msg void OnLocaleInegNumber();
        afx_msg void OnLocaleSdecimal();
        afx_msg void OnLocaleSthousand();
        afx_msg void OnChangeLpdecimalsep();
        afx_msg void OnChangeLpthousandsep();
        afx_msg void OnChangeNegativeorder();
        afx_msg void OnChangeNumdigits();
        afx_msg void OnCustomNumbersymbol();
        afx_msg void OnCustomDecimalsep();
        afx_msg void OnChangeNumberfmtName();
        afx_msg void OnChangeValueName();
        afx_msg void OnShowDigitTranslation();
        afx_msg void OnSelendokSamples();
        afx_msg void OnIndicGrouping();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GETNUMBERFORMAT_H__5271C375_9D98_4119_8642_2DD19D6ED81B__INCLUDED_)
