#if !defined(AFX_GETSTRINGTYPEEX_H__15D2A0EF_E557_4543_92F9_95EB1224AF69__INCLUDED_)
#define AFX_GETSTRINGTYPEEX_H__15D2A0EF_E557_4543_92F9_95EB1224AF69__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GetStringTypeEx.h : header file
//
#include "Function.h"
#include "HexEdit.h"

/////////////////////////////////////////////////////////////////////////////
// CGetStringTypeEx dialog

class CGetStringTypeEx : public CFunction
{
    DECLARE_DYNCREATE(CGetStringTypeEx)
// Construction
public:
        CGetStringTypeEx(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CGetStringTypeEx)
	enum { IDD = IDD_GETSTRINGTYPEEX };
	CButton	c_Refresh;
        CButton c_CT_CTYPE3;
        CButton c_CT_CTYPE2;
        CButton c_CT_CTYPE1;
        CButton c_Unicode;
        CButton c_String;
        CTreeCtrl       c_Output;
        CHexEdit c_UnicodeStart;
        CHexEdit        c_UnicodeEnd;
        CButton c_To;
        CEdit   c_Text;
        CSpinButtonCtrl c_SpinStartLO;
        CSpinButtonCtrl c_SpinStartHO;
        CSpinButtonCtrl c_SpinEndLO;
        CSpinButtonCtrl c_SpinEndHO;
	//}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGetStringTypeEx)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual BOOL IndexOK(CWnd * wnd);
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual void Initialize();

protected: // methods
        void updateControls();
        void SpinValue(CHexEdit & edit, CSpinButtonCtrl & low, CSpinButtonCtrl & high);
        void AddElement(TCHAR ch);
protected: // message handlers
        // Generated message map functions
        //{{AFX_MSG(CGetStringTypeEx)
        virtual BOOL OnInitDialog();
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnUnicode();
        afx_msg void OnString();
        afx_msg void OnChangeText();
        afx_msg void OnTo();
        afx_msg void OnChangeUnicodeStart();
        afx_msg void OnChangeUnicodeEnd();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnRefresh();
	afx_msg void OnCtCtype1();
	afx_msg void OnCtCtype2();
	afx_msg void OnCtCtype3();
	//}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GETSTRINGTYPEEX_H__15D2A0EF_E557_4543_92F9_95EB1224AF69__INCLUDED_)
