// GetDateFormat.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "GetTimeFormat.h"
#include "Query.h"
#include "ErrorString.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNCREATE(CGetTimeFormat, CFunction)

CGetTimeFormat * CGetTimeFormat::LogWnd = NULL;
/////////////////////////////////////////////////////////////////////////////
// CGetTimeFormat dialog


CGetTimeFormat::CGetTimeFormat(CWnd* pParent /*=NULL*/)
        : CFunction(CGetTimeFormat::IDD, pParent)
{
        //{{AFX_DATA_INIT(CGetTimeFormat)
        //}}AFX_DATA_INIT
}


void CGetTimeFormat::DoDataExchange(CDataExchange* pDX)
{
        CFunction::DoDataExchange(pDX);
        //{{AFX_DATA_MAP(CGetTimeFormat)
        DDX_Control(pDX, IDC_TT, c_tt);
        DDX_Control(pDX, IDC_T, c_t);
        DDX_Control(pDX, IDC_TIME_NOTIMEMARKER, c_TimeNoTimeMarker);
        DDX_Control(pDX, IDC_TIME_NOSECONDS, c_TimeNoSeconds);
        DDX_Control(pDX, IDC_TIME_NOMINUTESORSECONDS, c_TimeNoMinutesOrSeconds);
        DDX_Control(pDX, IDC_TIME_FORCE24HOURFORMAT, c_TimeForce24HourFormat);
        DDX_Control(pDX, IDC_SS, c_ss);
        DDX_Control(pDX, IDC_S, c_s);
        DDX_Control(pDX, IDC_HH24, c_HH);
        DDX_Control(pDX, IDC_HH12, c_hh);
        DDX_Control(pDX, IDC_H24, c_H);
        DDX_Control(pDX, IDC_H12, c_h);
        DDX_Control(pDX, IDC_SPACE, c_Space);
        DDX_Control(pDX, IDC_CUSTOM_BOX, c_CustomBox);
        DDX_Control(pDX, IDC_OTHER_BOX, c_OtherBox);
        DDX_Control(pDX, IDC_FORMATTING_BOX, c_FormattingBox);
        DDX_Control(pDX, IDC_FORMAT_TIME_BOX, c_FormatTimeBox);
        DDX_Control(pDX, IDC_DWFLAGS_BOX, c_dwFlagsBox);
        DDX_Control(pDX, IDC_HOUR_BOX, c_HourBox);
        DDX_Control(pDX, IDC_MINUTE_BOX, c_MinuteBox);
        DDX_Control(pDX, IDC_SECOND_BOX, c_SecondBox);
        DDX_Control(pDX, IDC_MARKER_BOX, c_MarkerBox);
        DDX_Control(pDX, IDC_PUNCTUATION, c_Punctuation);
        DDX_Control(pDX, IDC_FORMAT_BOX, c_FormatBox);
        DDX_Control(pDX, IDC_SYSTEMTIME_NAME_CAPTION, x_SystemTimeName);
        DDX_Control(pDX, IDC_SYSTEMTIME_NAME, c_SystemTimeName);
        DDX_Control(pDX, IDC_USE_EXPLICIT_FORMATTING, c_UseExplicitFormatting);
        DDX_Control(pDX, IDC_DEFAULT_FORMATTING, c_UseDefaultFormatting);
        DDX_Control(pDX, IDC_ENUMTIMEFORMATS, c_EnumTimeFormats);
        DDX_Control(pDX, IDC_SLASH, c_Slash);
        DDX_Control(pDX, IDC_QUOTE, c_Quote);
        DDX_Control(pDX, IDC_HYPHEN, c_Hyphen);
        DDX_Control(pDX, IDC_DOT, c_Dot);
        DDX_Control(pDX, IDC_COLON, c_Colon);
        DDX_Control(pDX, IDC_COMMA, c_Comma);
        DDX_Control(pDX, IDC_FORMATS, c_Formats);
        DDX_Control(pDX, IDC_CURRENT_SYSTEM_TIME, c_CurrentSystemTime);
        DDX_Control(pDX, IDC_SPECIFIC_TIME, c_SpecificTime);
        DDX_Control(pDX, IDC_YEAR, c_Year);
        DDX_Control(pDX, IDC_SPINSECOND, c_SpinSecond);
        DDX_Control(pDX, IDC_SPINMINUTE, c_SpinMinute);
        DDX_Control(pDX, IDC_SPINMILLISECONDS, c_SpinMilliseconds);
        DDX_Control(pDX, IDC_SPINHOUR, c_SpinHour);
        DDX_Control(pDX, IDC_SPINDAYOFWEEK, c_SpinDayOfWeek);
        DDX_Control(pDX, IDC_SPINDAY, c_SpinDay);
        DDX_Control(pDX, IDC_SECOND, c_Second);
        DDX_Control(pDX, IDC_MONTH, c_Month);
        DDX_Control(pDX, IDC_MINUTE, c_Minute);
        DDX_Control(pDX, IDC_MILLISECONDS, c_Milliseconds);
        DDX_Control(pDX, IDC_HOUR, c_Hour);
        DDX_Control(pDX, IDC_USE_CP_ACP, c_UseCPACP);
        DDX_Control(pDX, IDC_SYSTEMTIME, c_SYSTEMTIME);
        DDX_Control(pDX, IDC_SPINYEAR, c_SpinYear);
        DDX_Control(pDX, IDC_SPINMONTH, c_SpinMonth);
        DDX_Control(pDX, IDC_SECOND_CAPTION, x_Second);
        DDX_Control(pDX, IDC_RESULT, c_Result);
        DDX_Control(pDX, IDC_REMOVE, c_Remove);
        DDX_Control(pDX, IDC_NOUSEROVERRIDE, c_NoUserOverride);
        DDX_Control(pDX, IDC_MM, c_mm);
        DDX_Control(pDX, IDC_MINUTE_CAPTION, x_Minute);
        DDX_Control(pDX, IDC_DAYOFWEEK, c_DayOfWeek);
        DDX_Control(pDX, IDC_YEAR_CAPTION, x_Year);
        DDX_Control(pDX, IDC_DAY_CAPTION, x_Day);
        DDX_Control(pDX, IDC_MONTH_CAPTION, x_Month);
        DDX_Control(pDX, IDC_MILLISECOND_CAPTION, x_Milliseconds);
        DDX_Control(pDX, IDC_M, c_m);
        DDX_Control(pDX, IDC_HOUR_CAPTION, x_Hour);
        DDX_Control(pDX, IDC_MM, c_mm);
        DDX_Control(pDX, IDC_GETNOW, c_GetNow);
        DDX_Control(pDX, IDC_FORMAT, c_Format);
        DDX_Control(pDX, IDC_DAYOFWEEK_CAPTION, x_DayOfWeek);
        DDX_Control(pDX, IDC_DAY, c_Day);
        DDX_Control(pDX, IDC_ADD, c_Add);
        //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGetTimeFormat, CFunction)
        //{{AFX_MSG_MAP(CGetTimeFormat)
        ON_BN_CLICKED(IDC_ADD, OnAdd)
        ON_BN_CLICKED(IDC_CURRENT_SYSTEM_TIME, OnCurrentSystemTime)
        ON_BN_CLICKED(IDC_D, OnD)
        ON_BN_CLICKED(IDC_TIME_NOMINUTESORSECONDS, OnTimeNoMinutesOrSeconds)
        ON_BN_CLICKED(IDC_TIME_NOSECONDS, OnTimeNoSeconds)
        ON_BN_CLICKED(IDC_TIME_NOTIMEMARKER, OnTimeNoTimeMarker)
        ON_BN_CLICKED(IDC_TIME_FORCE24HOURFORMAT, OnTimeForce24HourFormat)
        ON_EN_CHANGE(IDC_DAY, OnChangeDay)
        ON_EN_CHANGE(IDC_DAYOFWEEK, OnChangeDayofweek)
        ON_BN_CLICKED(IDC_DD, OnDd)
        ON_CBN_EDITCHANGE(IDC_FORMAT, OnEditchangeFormat)
        ON_BN_CLICKED(IDC_GETNOW, OnGetnow)
        ON_BN_CLICKED(IDC_SS, Onss)
        ON_BN_CLICKED(IDC_S, Ons)
        ON_BN_CLICKED(IDC_TT, Ontt)
        ON_BN_CLICKED(IDC_T, Ont)
        ON_EN_CHANGE(IDC_HOUR, OnChangeHour)
        ON_BN_CLICKED(IDC_M, Onm)
        ON_EN_CHANGE(IDC_MILLISECONDS, OnChangeMilliseconds)
        ON_EN_CHANGE(IDC_MINUTE, OnChangeMinute)
        ON_BN_CLICKED(IDC_MM, Onmm)
        ON_BN_CLICKED(IDC_HH12, Onhh)
        ON_BN_CLICKED(IDC_HH24, OnHH)
        ON_EN_CHANGE(IDC_MONTH, OnChangeMonth)
        ON_BN_CLICKED(IDC_REMOVE, OnRemove)
        ON_EN_CHANGE(IDC_SECOND, OnChangeSecond)
        ON_BN_CLICKED(IDC_SPECIFIC_TIME, OnSpecificTime)
        ON_BN_CLICKED(IDC_H12, Onh)
        ON_EN_CHANGE(IDC_YEAR, OnChangeYear)
        ON_BN_CLICKED(IDC_H24, OnH)
        ON_WM_VSCROLL()
        ON_LBN_SELCHANGE(IDC_FORMATS, OnSelchangeFormats)
        ON_LBN_DBLCLK(IDC_FORMATS, OnDblclkFormats)
        ON_EN_CHANGE(IDC_FORMAT, OnChangeFormat)
        ON_BN_CLICKED(IDC_COLON, OnColon)
        ON_BN_CLICKED(IDC_COMMA, OnComma)
        ON_BN_CLICKED(IDC_DOT, OnDot)
        ON_BN_CLICKED(IDC_HYPHEN, OnHyphen)
        ON_BN_CLICKED(IDC_QUOTE, OnQuote)
        ON_BN_CLICKED(IDC_SLASH, OnSlash)
        ON_BN_CLICKED(IDC_ENUMTIMEFORMATS, OnEnumtimeformats)
        ON_BN_CLICKED(IDC_DEFAULT_FORMATTING, OnDefaultFormatting)
        ON_BN_CLICKED(IDC_USE_EXPLICIT_FORMATTING, OnUseExplicitFormatting)
        ON_EN_CHANGE(IDC_SYSTEMTIME_NAME, OnChangeSystemtimeName)
        ON_BN_CLICKED(IDC_SPACE, OnSpace)
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGetTimeFormat message handlers

BOOL CGetTimeFormat::OnInitDialog() 
   {
    CFunction::OnInitDialog();
        
    c_SpinYear.SetRange32(1601, 30827);
    c_SpinMonth.SetRange32(1, 12);
    c_SpinDayOfWeek.SetRange32(0, 6);
    c_SpinDay.SetRange32(1, 31);
    c_SpinHour.SetRange32(0, 23);
    c_SpinMinute.SetRange32(0, 59);
    c_SpinSecond.SetRange32(0, 59);
    c_SpinMilliseconds.SetRange32(0, 999);

    CheckRadioButton(IDC_CURRENT_SYSTEM_TIME, IDC_SPECIFIC_TIME, IDC_CURRENT_SYSTEM_TIME);
    CheckRadioButton(IDC_DEFAULT_FORMATTING, IDC_USE_EXPLICIT_FORMATTING, IDC_DEFAULT_FORMATTING);
    // TODO: Add extra initialization here
        
    return TRUE;  // return TRUE unless you set the focus to a control
                      // EXCEPTION: OCX Property Pages should return FALSE
}

void CGetTimeFormat::OnAdd() 
   {
    CString s;
    c_Format.GetWindowText(s);
    int n = c_Formats.FindStringExact(-1, s);
    if(n == CB_ERR)
       { /* not already there */
        c_Formats.AddString(s);
       } /* not already there */
    updateControls();
   }

/****************************************************************************
*                          CGetTimeFormat::OnRemove
* Result: void
*       
* Effect: 
*       Removes the current selection
****************************************************************************/

void CGetTimeFormat::OnRemove() 
   {
    int n = c_Formats.GetCurSel();
    if(n == CB_ERR)
       return; // we should not be here
    c_Formats.DeleteString(n);
    updateControls();
   }

/****************************************************************************
*                       CGetTimeFormat::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CGetTimeFormat::updateControls()
    {
     if(!initialized)
         return;
     BOOL enable;
     enable = c_SpecificTime.GetCheck() == BST_CHECKED;

     c_SYSTEMTIME.EnableWindow(enable);
     c_SystemTimeName.EnableWindow(enable);
     x_SystemTimeName.EnableWindow(enable);

     c_Year.EnableWindow(enable);
     x_Year.EnableWindow(enable);
     c_SpinYear.EnableWindow(enable);

     c_Month.EnableWindow(enable);
     x_Month.EnableWindow(enable);
     c_SpinMonth.EnableWindow(enable);

     c_Day.EnableWindow(enable);
     x_Day.EnableWindow(enable);
     c_SpinDay.EnableWindow(enable);

     c_DayOfWeek.EnableWindow(enable);
     x_DayOfWeek.EnableWindow(enable);
     c_SpinDayOfWeek.EnableWindow(enable);

     c_Hour.EnableWindow(enable);
     x_Hour.EnableWindow(enable);
     c_SpinHour.EnableWindow(enable);

     c_Minute.EnableWindow(enable);
     x_Minute.EnableWindow(enable);
     c_SpinMinute.EnableWindow(enable);

     c_Second.EnableWindow(enable);
     x_Second.EnableWindow(enable);
     c_SpinSecond.EnableWindow(enable);

     c_Milliseconds.EnableWindow(enable);
     x_Milliseconds.EnableWindow(enable);
     c_SpinMilliseconds.EnableWindow(enable);

     c_GetNow.EnableWindow(enable);

     enable = c_UseExplicitFormatting.GetCheck() == BST_CHECKED;
     
     c_FormatBox.EnableWindow(enable);
     c_Format.EnableWindow(enable);
     c_Formats.EnableWindow(enable);

     c_EnumTimeFormats.EnableWindow(enable);
     c_h.EnableWindow(enable);
     c_H.EnableWindow(enable);
     c_hh.EnableWindow(enable);
     c_HH.EnableWindow(enable);
     c_m.EnableWindow(enable);
     c_mm.EnableWindow(enable);
     c_s.EnableWindow(enable);
     c_ss.EnableWindow(enable);
     c_t.EnableWindow(enable);
     c_tt.EnableWindow(enable);
     c_Dot.EnableWindow(enable);
     c_Comma.EnableWindow(enable);
     c_Colon.EnableWindow(enable);
     c_Slash.EnableWindow(enable);
     c_Quote.EnableWindow(enable);
     c_Hyphen.EnableWindow(enable);
     c_Punctuation.EnableWindow(enable);
     c_Space.EnableWindow(enable);
     c_HourBox.EnableWindow(enable);
     c_MinuteBox.EnableWindow(enable);
     c_SecondBox.EnableWindow(enable);
     c_CustomBox.EnableWindow(enable);
     c_MarkerBox.EnableWindow(enable);
     
     //----------------------------------------------------------------
     // Add button
     //----------------------------------------------------------------
     CString s;
     c_Format.GetWindowText(s);
     s.TrimLeft();
     s.TrimRight();

     BOOL add = enable;
     if(!s.IsEmpty())
        { /* nonempty */
         int sel = c_Formats.FindStringExact(-1, s);
         if(sel != CB_ERR)
            add = FALSE;
        } /* nonempty */
     else
        { /* empty */
         add = FALSE;
        } /* empty */
     c_Add.EnableWindow(add);
     
     //----------------------------------------------------------------
     // Remove button
     //----------------------------------------------------------------
     int n = c_Formats.GetCurSel();
     BOOL remove = n != CB_ERR;
     remove &= enable;
     c_Remove.EnableWindow(remove);

     //----------------------------------------------------------------
     // Enable/Disable custom settings
     //----------------------------------------------------------------
     c_CustomBox.EnableWindow(enable);
     c_OtherBox.EnableWindow(!enable);
     c_FormattingBox.EnableWindow(!enable);
     c_FormatTimeBox.EnableWindow(!enable);
     c_dwFlagsBox.EnableWindow(!enable);
     c_UseCPACP.EnableWindow(!enable);
     c_NoUserOverride.EnableWindow(!enable);

    } // CGetTimeFormat::updateControls


void CGetTimeFormat::OnCurrentSystemTime() 
   {
    Refresh();
   }

void CGetTimeFormat::OnTimeNoMinutesOrSeconds() 
   {
    Refresh();
   }

void CGetTimeFormat::OnTimeNoSeconds() 
   {
    Refresh();
   }

void CGetTimeFormat::OnTimeNoTimeMarker() 
   {
    Refresh();
   }

void CGetTimeFormat::OnTimeForce24HourFormat() 
   {
    Refresh();
   }


/****************************************************************************
*                             CGetTimeFormat::OnD
*                             CGetTimeFormat::OnDd
*                            CGetTimeFormat::OnDdd
*                            CGetTimeFormat::OnDddd
*                             CGetTimeFormat::OnY
*                             CGetTimeFormat::OnH12
*                            CGetTimeFormat::OnH24
*
* Result: void
*       
* Effect: 
*       Inserts the appropriate text
****************************************************************************/

void CGetTimeFormat::OnD() 
   {
    Insert(_T("d"));
   }

void CGetTimeFormat::OnDd() 
   {
    Insert(_T("dd"));
   }

void CGetTimeFormat::Ons() 
   {
    Insert(_T("s"));
   }

void CGetTimeFormat::Onss() 
   {
    Insert(_T("ss"));
   }

void CGetTimeFormat::Onm() 
   {
    Insert(_T("m"));
   }

void CGetTimeFormat::Onmm() 
   {
    Insert(_T("mm"));
   }

void CGetTimeFormat::OnHH() 
   {
    Insert(_T("HH"));
   }

void CGetTimeFormat::Onhh() 
   {
    Insert(_T("hh"));
   }

void CGetTimeFormat::Onh() 
   {
   Insert(_T("h"));
   }

void CGetTimeFormat::OnH() 
   {
    Insert(_T("H"));
   }

void CGetTimeFormat::Ontt() 
   {
    Insert(_T("tt"));
   }

void CGetTimeFormat::Ont() 
   {
    Insert(_T("t"));
   }

void CGetTimeFormat::OnColon() 
   {
    Insert(_T(":"));
   }

void CGetTimeFormat::OnComma() 
   {
    Insert(_T(","));
   }

void CGetTimeFormat::OnDot() 
   {
    Insert(_T("."));
   }

void CGetTimeFormat::OnHyphen() 
   {
    Insert(_T("-"));
   }

void CGetTimeFormat::OnQuote() 
   {
    Insert(_T("'"));
   }

void CGetTimeFormat::OnSlash() 
   {
    Insert(_T("/"));
   }

void CGetTimeFormat::OnSpace() 
   {
    Insert(_T(" "));
   }


/****************************************************************************
*                     CGetTimeFormat::updateSpecificTime
* Result: void
*       
* Effect: 
*       Copies the controls back to the specificTime value
****************************************************************************/

void CGetTimeFormat::updateSpecificTime()
    {
     if(!initialized)
         return;
     specificTime.wYear = c_SpinYear.GetPos32();
     specificTime.wMonth = c_SpinMonth.GetPos32();
     specificTime.wDayOfWeek = c_SpinDayOfWeek.GetPos32();
     specificTime.wDay = c_SpinDay.GetPos32();
     specificTime.wHour = c_SpinHour.GetPos32();
     specificTime.wMinute = c_SpinMinute.GetPos32();
     specificTime.wSecond = c_SpinSecond.GetPos32();
     specificTime.wMilliseconds = c_SpinMilliseconds.GetPos32();
    } // CGetTimeFormat::updateSpecificTime

/****************************************************************************
*                        CGetTimeFormat::OnChangeYear
*                        CGetTimeFormat::OnChangeMonth
*                        CGetTimeFormat::OnChangeDay
*                        CGetTimeFormat::OnChangeHour
*                       CGetTimeFormat::OnChangeMinute
*                       CGetTimeFormat::OnChangeSecond
*                     CGetTimeFormat::OnChangeMillisecond
* Result: void
*       
* Effect: 
*       Forces a refresh
****************************************************************************/

void CGetTimeFormat::OnChangeYear() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetTimeFormat::OnChangeMonth() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetTimeFormat::OnChangeDay() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetTimeFormat::OnChangeDayofweek() 
   {
    updateSpecificTime();
    Refresh();        
   }

void CGetTimeFormat::OnChangeHour() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetTimeFormat::OnChangeMinute() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetTimeFormat::OnChangeSecond() 
   {
    updateSpecificTime();
    Refresh();
   }

void CGetTimeFormat::OnChangeMilliseconds() 
   {
    updateSpecificTime();
    Refresh();
   }


void CGetTimeFormat::OnEditchangeFormat() 
   {
    Refresh();
   }

void CGetTimeFormat::OnGetnow() 
   {
    GetSystemTime(&specificTime);
    c_SpinYear.SetPos32(specificTime.wYear);
    c_SpinMonth.SetPos32(specificTime.wMonth);
    c_SpinDayOfWeek.SetPos32(specificTime.wDayOfWeek);
    c_SpinDay.SetPos32(specificTime.wDay);
    c_SpinHour.SetPos32(specificTime.wHour);
    c_SpinMinute.SetPos32(specificTime.wMinute);
    c_SpinSecond.SetPos32(specificTime.wSecond);
    c_SpinMilliseconds.SetPos32(specificTime.wMilliseconds);
    Refresh();
   }

void CGetTimeFormat::OnSpecificTime() 
   {
    Refresh();
   }

void CGetTimeFormat::OnChangeSystemtimeName() 
   {
    Refresh();
   }
   

/****************************************************************************
*                          CGetTimeFormat::OnVScroll
* Inputs:
*       UINT nSBCode:
*       UINT nPos:
*       CScrollBar * pScrollBar
* Result: void
*       
* Effect: 
*       If the scrollbar is non-NULL, it is from an internal control and
*       should be ignored
****************************************************************************/

void CGetTimeFormat::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
   {
    if(pScrollBar != NULL)
       { /* local spin control */
        return; // do nothing
       } /* local spin control */
    CFunction::OnVScroll(nSBCode, nPos, pScrollBar);
   }

/****************************************************************************
*                           CGetTimeFormat::Insert
* Inputs:
*       const CString & text: Text to add
* Result: void
*       
* Effect: 
*       Adds the text
****************************************************************************/

void CGetTimeFormat::Insert(const CString & text)
    {
     c_Format.ReplaceSel(text);
     Refresh();
    } // CGetTimeFormat::Insert

/****************************************************************************
*                           CGetTimeFormat::Refresh
* Result: void
*       
* Effect: 
*       Refreshes the contents
****************************************************************************/

void CGetTimeFormat::Refresh()
    {
     if(!initialized)
         return;
     EnableQuery(QUERY_USE_CP_ACP, TRUE);
     EnableQuery(QUERY_NOUSEROVERRIDE, TRUE);
     EnableQuery(QUERY_DWORD, FALSE);
     updateControls();

     CString or = QueryTemplate(_T("[OR]"));

     LPTSTR format = NULL;
     CString formatString;
     //----------------------------------------------------------------
     // %1: The LCID
     //----------------------------------------------------------------
     CString localeName = GetLocaleName();

     //----------------------------------------------------------------
     // %2: The time format string
     //----------------------------------------------------------------
     if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
        { /* default formatting */
         format = NULL;
         formatString = _T("NULL");
        } /* default formatting */
     else
        { /* explicit formatting */
         c_Format.GetWindowText(formatString);
         format = (LPTSTR)(LPCTSTR)formatString;
        } /* explicit formatting */

     //----------------------------------------------------------------
     // %3: The option flags
     //----------------------------------------------------------------
     DWORD flags = 0;
     CString flagString;
     if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
        { /* default formatting */
         GetOptionFlags(flagString, flags, or);

         //----------------------------------------------------------------
         // Format flags
         //----------------------------------------------------------------
         CString fmtflags;
         if(c_TimeNoMinutesOrSeconds.GetCheck() == BST_CHECKED)
            { /* NoMinutesOrSeconds */
             AppendFlags(flagString, _T("TIME_NOMINUTESORSECONDS"), or);
             flags |= TIME_NOMINUTESORSECONDS;
            } /* NoMinutesOrSeconds */

         if(c_TimeNoSeconds.GetCheck() == BST_CHECKED)
            { /* TimeNoSeconds */
             AppendFlags(flagString, _T("TIME_NOSECONDS"), or);
             flags |= TIME_NOSECONDS;
            } /* TimeNoSeconds */

         if(c_TimeNoTimeMarker.GetCheck() == BST_CHECKED)
            { /* NoTimeMarker */
             AppendFlags(flagString, _T("TIME_NOTIMEMARKER"), or);
             flags |= TIME_NOTIMEMARKER;
            } /* NoTimeMarker */

         if(c_TimeForce24HourFormat.GetCheck() == BST_CHECKED)
            { /* Force 24 hour */
             AppendFlags(flagString, _T("TIME_FORCE24HOURFORMAT"), or);
             flags |= TIME_FORCE24HOURFORMAT;
            } /* Force 24 hour */

        } /* default formatting */
     else
        { /* explicit formatting */
         flags = 0;
         flagString = _T("0");
        } /* explicit formatting */

     if(flags & LOCALE_USE_CP_ACP)
        c_UseCPACP.SetWindowText(_T("LOCALE_USE_CAP_ACP"));
     else
        c_UseCPACP.SetWindowText(_T(""));

     if(flags & LOCALE_NOUSEROVERRIDE)
        c_NoUserOverride.SetWindowText(_T("LOCALE_NOUSEROVERRIDE"));
     else
        c_NoUserOverride.SetWindowText(_T(""));

     if(flagString.IsEmpty())
        flagString = _T("0");

     //----------------------------------------------------------------
     // %4: Length: not used
     //----------------------------------------------------------------


     //----------------------------------------------------------------
     // %5: The variable name
     //----------------------------------------------------------------
     BOOL enable = TRUE;

     CString variable;

     //     variable = QueryVariable();
     //     variable.TrimLeft();
     //     variable.TrimRight();
     //     if(variable.IsEmpty())
     //        { /* empty */
     //         variable = _T("?");
     //         enable = FALSE;
     //        } /* empty */
     variable = GetVariable();

     //----------------------------------------------------------------
     // %6: Options as a decimal number
     //----------------------------------------------------------------
     CString flagsDecimal;
     flagsDecimal.Format(_T("%d"), flags);

     //----------------------------------------------------------------
     // %7: OR
     //----------------------------------------------------------------
     // This was already set up

     //----------------------------------------------------------------
     // %8: The locale ID as a decimal integer
     //----------------------------------------------------------------
     LCID lcid = QueryLocale();
     CString localeDecimal;
     localeDecimal.Format(_T("%d"), lcid);

     //----------------------------------------------------------------
     // %9: time pointer
     //----------------------------------------------------------------
     LPSYSTEMTIME time;
     CString timeString;

     CString fmt;
     if(c_SpecificTime.GetCheck() == BST_CHECKED)
        { /* user-defined time */
         time = &specificTime;
         c_SystemTimeName.GetWindowText(timeString);
         timeString.TrimLeft();
         timeString.TrimRight();
         if(timeString.IsEmpty())
            timeString = _T("&timevalue"); // make this a control someday
         if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
            fmt = QueryTemplate(_T("[GetTimeFormat:SPECIFICTIME:DEFAULT]"));
         else
            fmt = QueryTemplate(_T("[GetTimeFormat:SPECIFICTIME]"));
        } /* user-defined time */
     else
        { /* system time */
         time = NULL;
         timeString = _T("");
         if(c_UseDefaultFormatting.GetCheck() == BST_CHECKED)
            fmt = QueryTemplate(_T("[GetTimeFormat:NOW:DEFAULT]"));
         else
            fmt = QueryTemplate(_T("[GetTimeFormat:NOW]"));
        } /* system time */


     //----------------------------------------------------------------
     // %10: not used
     //----------------------------------------------------------------

     //----------------------------------------------------------------
     // %11: not used
     //----------------------------------------------------------------

     //-----------------------------------------------------------------------------
     // Create the actual text from the template
     //-----------------------------------------------------------------------------
     CString text;

     //-----------------------------------------------------------------------------------------------
     //                        %1              %2           %3         %4      %5         %6         %7        %8           %9        %10     %11
     text.FormatMessage(fmt, localeName,  formatString, flagString, _T(""), variable, flagsDecimal,  or, localeDecimal, timeString, _T(""), _T(""));

     //-----------------------------------------------------------------------------------------------
     SetCode(text, enable);

     // .. Set the time value here
     { /* GetTimeFormat */
      int length = GetTimeFormat(lcid, flags, time, format, NULL, 0);
      if(length == 0)
         { /* error */
          DWORD err = GetLastError();
          c_Result.SetWindowText(ErrorString(err));
         } /* error */
      else
         { /* got length */
          CString result;
          LPTSTR p = result.GetBuffer(length);
          if(!::GetTimeFormat(lcid, flags, time, format, p, length))
             { /* failed */
              DWORD err = GetLastError();
              result.ReleaseBuffer();
              c_Result.SetWindowText(ErrorString(err));
             } /* failed */
          else
              { /* got date */
              result.ReleaseBuffer();
              c_Result.SetWindowText(result);
              } /* got date */
         } /* got length */
     } /* GetTimeFormat */
     
    } // CGetTimeFormat::Refresh

/****************************************************************************
*                       CGetTimeFormat::OnDblclkFormats
* Result: void
*       
* Effect: 
*       Puts current selection in edit control
****************************************************************************/

void CGetTimeFormat::OnDblclkFormats() 
   {
    int n = c_Formats.GetCurSel();
    if(n == CB_ERR)
       return;
    CString s;
    c_Formats.GetText(n, s);
    c_Format.SetWindowText(s);
   }

/****************************************************************************
*                       CGetTimeFormat::OnChangeFormat
*                     CGetTimeFormat::OnSelchangeFormats()
* Result: void
*       
* Effect: 
*       Refreshes the display
****************************************************************************/

void CGetTimeFormat::OnChangeFormat() 
   {
    Refresh();
   }

void CGetTimeFormat::OnSelchangeFormats() 
   {
    updateControls();
   }

/****************************************************************************
*                     CGetTimeFormat::EnumTimeFormatsProc
* Inputs:
*       LPTSTR fmt: Format
* Result: BOOL
*       TRUE, always
* Effect: 
*       Adds the format the the listbox
****************************************************************************/

BOOL CALLBACK CGetTimeFormat::EnumTimeFormatsProc(LPTSTR fmt)
   {
    int n = LogWnd->c_Formats.FindStringExact(-1, fmt);
    if(n != CB_ERR)
       return TRUE; // ignore and keep running
    int item = LogWnd->c_Formats.AddString(fmt);
    LogWnd->c_Formats.SetItemData(item, TRUE); // indicate built-in format
    return TRUE;
   } // CGetTimeFormat::EnumTimeFormatsProc


/****************************************************************************
*                      CGetTimeFormat::OnEnumtimeFormats
* Result: void
*       
* Effect: 
*       Enumerates the time format
****************************************************************************/

void CGetTimeFormat::OnEnumtimeformats() 
   {
    LCID locale = QueryLocale();
    LogWnd = this;
    DWORD flags = 0;
    flags |= QueryFlag(QUERY_USE_CP_ACP);
    
    if(!::EnumTimeFormats(EnumTimeFormatsProc, locale, flags))
       { /* error */
        DWORD err = ::GetLastError();
        return;
       } /* error */    
   }



void CGetTimeFormat::OnDefaultFormatting() 
   {
    Refresh();
   }

void CGetTimeFormat::OnUseExplicitFormatting() 
   {
    Refresh();
   }

/****************************************************************************
*                         CGetTimeFormat::Initialize
* Result: void
*       
* Effect: 
*       Refreshes the display
****************************************************************************/

void CGetTimeFormat::Initialize()
    {
     variable = _T("timestring");
     c_SystemTimeName.SetWindowText(_T("timevalue"));
     OnGetnow(); // implies Refresh();
    } // CGetTimeFormat::Initialize


/****************************************************************************
*                      CGetTimeFormat::SetFontToControls
* Result: void
*       
* Effect: 
*       Sets the font
****************************************************************************/

void CGetTimeFormat::SetFontToControls()
    {
#ifdef _UNICODE
     c_Result.SetFont(&UnicodeFont);
#endif
    } // CGetTimeFormat::SetFontToControls


/****************************************************************************
*                           CGetTimeFormat::IndexOK
* Inputs:
*       CWnd * wnd: Window to test
* Result: BOOL
*       TRUE if window should be indexed
*       FALSE if window should not be indexed
****************************************************************************/

BOOL CGetTimeFormat::IndexOK(CWnd * wnd)
    {
     if(wnd == &c_Result)
        return FALSE;
     return TRUE;
    } // CGetTimeFormat::IndexOK
