#if !defined(AFX_GETTIMEFORMAT_H__A7579108_D498_4EC8_8F9C_4A25CD5FEE2A__INCLUDED_)
#define AFX_GETTIMEFORMAT_H__A7579108_D498_4EC8_8F9C_4A25CD5FEE2A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// GetTimeFormat.h : header file
//
#include "Function.h"
#include "WhatIsThisEdit.h"
#include "WhatIsItButton.h"

#include "SpinButtonCtrl7.h"

/////////////////////////////////////////////////////////////////////////////
// CGetTimeFormat dialog

class CGetTimeFormat : public CFunction
{
    DECLARE_DYNCREATE(CGetTimeFormat)
// Construction
public:
        CGetTimeFormat(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CGetTimeFormat)
        enum { IDD = IDD_GETTIMEFORMAT };
        CWhatIsItButton c_tt;
        CWhatIsItButton c_TimeNoTimeMarker;
        CWhatIsItButton c_TimeNoSeconds;
        CWhatIsItButton c_TimeNoMinutesOrSeconds;
        CWhatIsItButton c_TimeForce24HourFormat;
        CWhatIsItButton c_t;
        CWhatIsItButton c_ss;
        CWhatIsItButton c_s;
        CWhatIsItButton c_HH;
        CWhatIsItButton c_hh;
        CWhatIsItButton c_H;
        CWhatIsItButton c_h;
        CWhatIsItButton c_Space;
        CButton c_CustomBox;
        CButton c_OtherBox;
        CButton c_FormattingBox;
        CButton c_FormatTimeBox;
        CButton c_dwFlagsBox;
        CButton c_HourBox;
        CButton c_MinuteBox;
        CButton c_SecondBox;
        CButton c_MarkerBox;
        CButton c_Punctuation;
        CStatic x_Format;
        CButton c_FormatBox;
        CStatic x_SystemTimeName;
        CWhatIsThisEdit c_SystemTimeName;
        CWhatIsItButton c_UseExplicitFormatting;
        CWhatIsItButton c_UseDefaultFormatting;
        CWhatIsItButton c_EnumTimeFormats;
        CWhatIsItButton c_Slash;
        CWhatIsItButton c_Quote;
        CWhatIsItButton c_Hyphen;
        CWhatIsItButton c_Dot;
        CWhatIsItButton c_Colon;
        CWhatIsItButton c_Comma;
        CListBox        c_Formats;
        CWhatIsItButton c_CurrentSystemTime;
        CWhatIsItButton c_SpecificTime;
        CWhatIsThisEdit c_Year;
        CSpinButtonCtrl7 c_SpinSecond;
        CSpinButtonCtrl7 c_SpinMinute;
        CSpinButtonCtrl7 c_SpinMilliseconds;
        CSpinButtonCtrl7 c_SpinHour;
        CSpinButtonCtrl7 c_SpinDayOfWeek;
        CSpinButtonCtrl7 c_SpinDay;
        CWhatIsThisEdit c_Second;
        CWhatIsThisEdit c_Month;
        CWhatIsThisEdit c_Minute;
        CWhatIsThisEdit c_Milliseconds;
        CWhatIsThisEdit c_Hour;
        CWhatIsThisEdit c_DayOfWeek;
        CStatic x_Day;
        CWhatIsItButton c_yyyy;
        CWhatIsItButton c_yy;
        CStatic x_Year;
        CWhatIsItButton c_y;
        CStatic c_UseCPACP;
        CButton c_SYSTEMTIME;
        CSpinButtonCtrl7 c_SpinYear;
        CSpinButtonCtrl7 c_SpinMonth;
        CStatic x_Second;
        CWhatIsThisEdit c_Result;
        CWhatIsItButton c_Remove;
        CStatic c_NoUserOverride;
        CStatic x_Month;
        CWhatIsItButton c_mm;
        CWhatIsItButton c_m;
        CStatic x_Minute;
        CStatic x_Milliseconds;
        CStatic x_Hour;
        CWhatIsItButton c_GetNow;
        CWhatIsThisEdit       c_Format;
        CStatic x_DayOfWeek;
        CStatic c_Day;
        CWhatIsItButton c_Add;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CGetTimeFormat)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void Initialize();
        virtual void SetFontToControls();
protected: // methods        
        void updateControls();
        void Insert(const CString & text);
        void updateSpecificTime();
        BOOL IndexOK(CWnd * wnd);
protected: // static objects
        static CGetTimeFormat * LogWnd;
        static BOOL CALLBACK EnumTimeFormatsProc(LPTSTR fmt);
protected: // data
        SYSTEMTIME specificTime;
protected: // Message handlers
        // Generated message map functions
        //{{AFX_MSG(CGetTimeFormat)
        virtual BOOL OnInitDialog();
        afx_msg void OnAdd();
        afx_msg void OnCurrentSystemTime();
        afx_msg void OnD();
        afx_msg void OnChangeDay();
        afx_msg void OnChangeDayofweek();
        afx_msg void OnDd();
        afx_msg void OnTimeNoMinutesOrSeconds();
        afx_msg void OnEditchangeFormat();
        afx_msg void OnGetnow();
        afx_msg void Ontt();
        afx_msg void Ont();
        afx_msg void OnChangeHour();
        afx_msg void Onss();
        afx_msg void OnChangeMilliseconds();
        afx_msg void OnChangeMinute();
        afx_msg void Onmm();
        afx_msg void OnTimeNoSeconds();
        afx_msg void OnTimeNoTimeMarker();
        afx_msg void OnTimeForce24HourFormat();
        afx_msg void Onm();
        afx_msg void Ons();
        afx_msg void OnChangeMonth();
        afx_msg void OnRemove();
        afx_msg void OnChangeSecond();
        afx_msg void OnSpecificTime();
        afx_msg void Onh();
        afx_msg void Onhh();
        afx_msg void OnChangeYear();
        afx_msg void OnH();
        afx_msg void OnHH();
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        afx_msg void OnSelchangeFormats();
        afx_msg void OnDblclkFormats();
        afx_msg void OnChangeFormat();
        afx_msg void OnColon();
        afx_msg void OnComma();
        afx_msg void OnDot();
        afx_msg void OnHyphen();
        afx_msg void OnQuote();
        afx_msg void OnSlash();
        afx_msg void OnEnumtimeformats();
        afx_msg void OnDefaultFormatting();
        afx_msg void OnUseExplicitFormatting();
        afx_msg void OnChangeSystemtimeName();
        afx_msg void OnSpace();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GETTIMEFORMAT_H__A7579108_D498_4EC8_8F9C_4A25CD5FEE2A__INCLUDED_)
