#if !defined(AFX_HELP_H__CCF31778_FE55_4169_AEDF_AFD5664C8514__INCLUDED_)
#define AFX_HELP_H__CCF31778_FE55_4169_AEDF_AFD5664C8514__INCLUDED_
// Copyright  2005, Joseph M. Newcomer, All Rights Reserved
// You are free to redistribute FlounderClock providing all copyrights are left intact
// You must record any changes you make to this source by putting // and your
// initials at the end of each line you change. You may not remove any lines
// from this source; instead, put // in front of them and your initials at the end.
// You may not charge any fee for the redistribution, nor incorporate this code in
// any commercial product. This is freeware, and must remain so.
//

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Help.h : header file
//
#include "RTFHelp.h"
/////////////////////////////////////////////////////////////////////////////
// CHelp dialog

class CHelp : public CDialog
{
// Construction
public:
        CHelp(CWnd* pParent = NULL);   // standard constructor

        static CString MakeHelpName(const CString & name);
        static HRSRC FindHelpResource(const CString & helpname);
// Dialog Data
        //{{AFX_DATA(CHelp)
        enum { IDD = IDD_HELP };
        CRTFHelp c_Text;
        //}}AFX_DATA
        CString m_HelpName;

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CHelp)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        BOOL LoadHelpText();
        void OnURLLink(NMHDR * pNotifyStruct, LRESULT * pResult);
        BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT * result);
        afx_msg LRESULT OnPosition(WPARAM, LPARAM);
        BOOL FirstFocus;

        // Generated message map functions
        //{{AFX_MSG(CHelp)
        virtual BOOL OnInitDialog();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnSetfocusText(NMHDR* pNMHDR, LRESULT* pResult);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HELP_H__CCF31778_FE55_4169_AEDF_AFD5664C8514__INCLUDED_)
