// HexEdit.cpp : implementation file
//

#include "stdafx.h"
#include "HexEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHexEdit

void CHexEdit::PreSubclassWindow() 
   {
    ASSERT(GetStyle() & ES_UPPERCASE); // Must have UPPERCASE attribute!
    ModifyStyle(0, ES_UPPERCASE);
    CWhatIsThisEdit::PreSubclassWindow();

   }


CHexEdit::CHexEdit()
{
}

CHexEdit::~CHexEdit()
{
}


BEGIN_MESSAGE_MAP(CHexEdit, CWhatIsThisEdit)
        //{{AFX_MSG_MAP(CHexEdit)
        ON_WM_CHAR()
        //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHexEdit message handlers

void CHexEdit::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags) 
   {
    switch(nChar)
       { /* validate */
        case _T('0'):
        case _T('1'):
        case _T('2'):
        case _T('3'):
        case _T('4'):
        case _T('5'):
        case _T('6'):
        case _T('7'):
        case _T('8'):
        case _T('9'):
        case _T('A'):
        case _T('B'):
        case _T('C'):
        case _T('D'):
        case _T('E'):
        case _T('F'):
           break;
        case _T('a'):
        case _T('b'):
        case _T('c'):
        case _T('d'):
        case _T('e'):
        case _T('f'):
           break;
        case _T('\b'):
           break;
        default:
           MessageBeep(0);
           return;
       } /* validate */
    CWhatIsThisEdit::OnChar(nChar, nRepCnt, nFlags);
   }

/****************************************************************************
*                           CHexEdit::GetWindowText
* Inputs:
*       UINT n: Number to set
* Result: void
*       
* Effect: 
*       Retrieves the number
****************************************************************************/

void CHexEdit::GetWindowText(UINT & n)
    {
     CString s;
     CWhatIsThisEdit::GetWindowText(s);
     n = _tcstoul(s, NULL, 16);
    } // CHexEdit::GetWindowText

/****************************************************************************
*                           CHexEdit::SetWindowText
* Inputs:
*       UINT n: Value to set
* Result: void
*       
* Effect: 
*       Sets the value in the window
****************************************************************************/

void CHexEdit::SetWindowText(UINT n)
    {
     CString s;
#ifdef _UNICODE     
     s.Format(_T("%04X"), n);
#else
     s.Format(_T("%02X"), n);
#endif
     CWhatIsThisEdit::SetWindowText(s);
    } // CHexEdit::SetWindowText

/****************************************************************************
*                       CHexEdit::SetWindowTextNoNotify
* Inputs:
*       UINT n: Value to set
* Result: void
*       
* Effect: 
*       Sets the value without notification
****************************************************************************/

void CHexEdit::SetWindowTextNoNotify(UINT n)
    {
     CString s;
#ifdef _UNICODE
     s.Format(_T("%04X"), n);
#else
     s.Format(_T("%02X"), n);
#endif
     CWhatIsThisEdit::SetWindowTextNoNotify(s);
    } // CHexEdit::SetWindowTextNoNotify
