#if !defined(AFX_HISTORY_H__D7054E7A_5C58_408D_B266_EE15AF0DAAB1__INCLUDED_)
#define AFX_HISTORY_H__D7054E7A_5C58_408D_B266_EE15AF0DAAB1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// History.h : header file
//
#include "SmartDropDown.h"

/////////////////////////////////////////////////////////////////////////////
// CHistory window

class History {
    public:
       History(const CString & s) { text = s; }
       History(LPCTSTR s) { text = s; }
       History();
       CString GetText() { return text; }
    protected:
       CString text;
};

class CHistory : public CSmartDropdown
{
// Construction
public:
        CHistory();

// Attributes
public:

// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CHistory)
        public:
        virtual void DeleteItem(LPDELETEITEMSTRUCT dis);
        virtual void DrawItem(LPDRAWITEMSTRUCT dis);
        virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CHistory();
        int AddString(History * h) { return CComboBox::AddString((LPCTSTR)h); }
        int InsertString(int n, History * h) { return CComboBox::InsertString(n, (LPCTSTR)h); }
        int IsPresent(History * h);
        int InsertConditionally(int n, History * h);
        History * GetItemData(int n) { return (History *)CComboBox::GetItemDataPtr(n); }

        // Generated message map functions
protected:
        //{{AFX_MSG(CHistory)
        afx_msg void OnDropdown();
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HISTORY_H__D7054E7A_5C58_408D_B266_EE15AF0DAAB1__INCLUDED_)
