#if !defined(AFX_ISNLSDEFINEDSTRING_H__CD69C125_3A71_4D10_8B43_C81DCC600B48__INCLUDED_)
#define AFX_ISNLSDEFINEDSTRING_H__CD69C125_3A71_4D10_8B43_C81DCC600B48__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IsNLSDefinedString.h : header file
//
#include "Function.h"
#include "WhatIsThisEdit.h"
#include "WhatIsItButton.h"
#include "SpinButtonCtrl7.h"
#include "HexEditCtrl.h"

/////////////////////////////////////////////////////////////////////////////
// CIsNLSDefinedString dialog

class CIsNLSDefinedString : public CFunction
{
    DECLARE_DYNCREATE(CIsNLSDefinedString)
// Construction
public:
        CIsNLSDefinedString(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CIsNLSDefinedString)
        enum { IDD = IDD_ISNLSDEFINEDSTRING };
        CWhatIsItButton c_ExplicitLength;
        CWhatIsItButton c_NULL;
        CStatic x_NLSVersionInfoSize;
        CWhatIsItButton c_COMPARE_STRING;
        CWhatIsThisEdit   c_NLSVersionInfoSize;
        CButton c_NLSVERSIONINFO;
        CStatic x_NLSVersion;
        CWhatIsThisEdit   c_NLSVersion;
        CWhatIsThisEdit   c_Length;
        CSpinButtonCtrl7 c_SpinLength;
        CStatic c_Status;
        CRichEditCtrlEx   c_Wide;
        CHexEditCtrl c_WideHex;
        CStatic x_DefinedVersion;
        CWhatIsThisEdit   c_DefinedVersion;
        CWhatIsItButton c_DefaultLength;
        CWhatIsItButton c_Compatible;
        CWhatIsItButton c_GetNLSVersion;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CIsNLSDefinedString)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void Initialize();
        virtual void SetFontToControls();
protected: // methods
protected: // message handlers

        // Generated message map functions
        //{{AFX_MSG(CIsNLSDefinedString)
        afx_msg void OnChangeWidehex();
        afx_msg void OnSelchangeWidehex(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSelchangeWide(NMHDR* pNMHDR, LRESULT* pResult);
        virtual BOOL OnInitDialog();
        afx_msg void OnCompatible();
        afx_msg void OnDefaultlength();
        afx_msg void OnExplicitLength();
        afx_msg void OnGetnlsversion();
        afx_msg void OnChangeLength();
        afx_msg void OnNull();
        afx_msg void OnChangeWide();
        afx_msg void OnCompareString();
        afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ISNLSDEFINEDSTRING_H__CD69C125_3A71_4D10_8B43_C81DCC600B48__INCLUDED_)
