#if !defined(AFX_ISTEXTUNICODE_H__E5D7B7A8_5521_45BC_8FF5_5C2E4E5F2133__INCLUDED_)
#define AFX_ISTEXTUNICODE_H__E5D7B7A8_5521_45BC_8FF5_5C2E4E5F2133__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// IsTextUnicode.h : header file
//

#include "function.h"
#include "RichEditCtrlEx.h"
#include "WhatIsItButton.h"
#include "HexEditCtrl.h"
/////////////////////////////////////////////////////////////////////////////
// CIsTextUnicode dialog

class CIsTextUnicode : public CFunction
{
    DECLARE_DYNCREATE(CIsTextUnicode)
// Construction
public:
        CIsTextUnicode(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CIsTextUnicode)
        enum { IDD = IDD_ISTEXTUNICODE };
        CRichEditCtrlEx c_Wide;
        CHexEditCtrl c_WideHex;
        CStatic c_Result;
        CWhatIsItButton c_IS_TEXT_UNICODE_ODD_LENGTH;
        CWhatIsItButton c_IS_TEXT_UNICODE_ILLEGAL_CHARS;
        CWhatIsItButton c_IS_TEXT_UNICODE_UNICODE_MASK;
        CWhatIsItButton c_IS_TEXT_UNICODE_STATISTICS;
        CWhatIsItButton c_IS_TEXT_UNICODE_SIGNATURE;
        CWhatIsItButton c_IS_TEXT_UNICODE_REVERSE_STATISTICS;
        CWhatIsItButton c_IS_TEXT_UNICODE_REVERSE_SIGNATURE;
        CWhatIsItButton c_IS_TEXT_UNICODE_REVERSE_MASK;
        CWhatIsItButton c_IS_TEXT_UNICODE_REVERSE_CONTROLS;
        CWhatIsItButton c_IS_TEXT_UNICODE_REVERSE_ASCII16;
        CWhatIsItButton c_IS_TEXT_UNICODE_NULL_BYTES;
        CWhatIsItButton c_IS_TEXT_UNICODE_NOT_UNICODE_MASK;
        CWhatIsItButton c_IS_TEXT_UNICODE_NOT_ASCII_MASK;
        CWhatIsItButton c_IS_TEXT_UNICODE_DBCS_LEADBYTE;
        CWhatIsItButton c_IS_TEXT_UNICODE_CONTROLS;
        CWhatIsItButton c_IS_TEXT_UNICODE_ASCII16;
        CWhatIsItButton c_0X8000;
        CWhatIsItButton c_0X4000;
        CWhatIsItButton c_0X2000;
        CWhatIsItButton c_0X0800;
        CWhatIsItButton c_VS7;
        CWhatIsItButton c_VS6;

        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_ODD_LENGTH;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_ILLEGAL_CHARS;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_STATISTICS;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_SIGNATURE;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_REVERSE_STATISTICS;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_REVERSE_SIGNATURE;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_REVERSE_CONTROLS;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_REVERSE_ASCII16;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_NULL_BYTES;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_NOT_UNICODE_MASK;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_NOT_ASCII_MASK;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_DBCS_LEADBYTE;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_CONTROLS;
        CWhatIsItButton c_OUT_IS_TEXT_UNICODE_ASCII16;
        CWhatIsItButton c_OUT_0X8000;
        CWhatIsItButton c_OUT_0X4000;
        CWhatIsItButton c_OUT_0X2000;
        CWhatIsItButton c_OUT_0X0800;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CIsTextUnicode)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        void EnableMasks();
        UINT ControlsToFlags();
        void GetFlags(CString & options, DWORD & flags, const CString & or);

protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls();
        virtual void Initialize();
        
        // Generated message map functions
        //{{AFX_MSG(CIsTextUnicode)
        afx_msg void OnVs6();
        afx_msg void OnVs7();
        afx_msg void On0x0800();
        afx_msg void On0x2000();
        afx_msg void On0x4000();
        afx_msg void On0x8000();
        afx_msg void OnIsTextUnicodeAscii16();
        afx_msg void OnIsTextUnicodeControls();
        afx_msg void OnIsTextUnicodeDbcsLeadbyte();
        afx_msg void OnIsTextUnicodeNotAsciiMask();
        afx_msg void OnIsTextUnicodeNotUnicodeMask();
        afx_msg void OnIsTextUnicodeNullBytes();
        afx_msg void OnIsTextUnicodeReverseAscii16();
        afx_msg void OnIsTextUnicodeReverseControls();
        afx_msg void OnIsTextUnicodeReverseMask();
        afx_msg void OnIsTextUnicodeReverseSignature();
        afx_msg void OnIsTextUnicodeReverseStatistics();
        afx_msg void OnIsTextUnicodeSignature();
        afx_msg void OnIsTextUnicodeStatistics();
        afx_msg void OnIsTextUnicodeUnicodeMask();
        afx_msg void OnSelchangeWide(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnSelchangeWidehex(NMHDR* pNMHDR, LRESULT* pResult);
        afx_msg void OnChangeWide();
        afx_msg void OnChangeWidehex();
        virtual BOOL OnInitDialog();
        afx_msg void OnIsTextUnicodeIllegalChars();
        afx_msg void OnIsTextUnicodeOddLength();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ISTEXTUNICODE_H__E5D7B7A8_5521_45BC_8FF5_5C2E4E5F2133__INCLUDED_)
