#if !defined(AFX_LCID_H__31AA6F8F_5FDC_417E_B5E2_F611B2021998__INCLUDED_)
#define AFX_LCID_H__31AA6F8F_5FDC_417E_B5E2_F611B2021998__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LCID.h : header file
//
#include "Function.h"
#include "IDCombo.h"
#include "WhatIsThisEdit.h"
/////////////////////////////////////////////////////////////////////////////
// CLCID dialog

class CLCID : public CFunction
{
    DECLARE_DYNCREATE(CLCID)
// Construction
public:
        CLCID(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
        //{{AFX_DATA(CLCID)
        enum { IDD = IDD_LCID };
        CStatic c_LCID;
        CWhatIsThisEdit c_MakeLCID;
        CWhatIsThisEdit c_MakeLangID;
        CStatic v_SubLanguage;
        CListBox        c_SubLanguage;
        CStatic v_SortID;
        CIDCombo        c_SortID;
        CStatic v_Language;
        CIDCombo        c_Language;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CLCID)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected: // virtual methods
        virtual void Refresh();
        virtual void SetFontToControls() { }
        virtual void Initialize();
        virtual BOOL IndexOK(CWnd * wnd);
protected: // methods
        void UpdateLanguage();
protected: // data
        static LCID SubLanguageFilter;
        static CLCID * LogWnd;
        static BOOL CALLBACK GetSubLanguages(LPTSTR);
protected: // message handlers

        // Generated message map functions
        //{{AFX_MSG(CLCID)
        virtual BOOL OnInitDialog();
        afx_msg void OnSelendokLanguage();
        afx_msg void OnSelchangeSublanguage();
        afx_msg void OnSelendokSortid();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LCID_H__31AA6F8F_5FDC_417E_B5E2_F611B2021998__INCLUDED_)
