#if !defined(AFX_RTFHELP_H__2F656B00_9534_4E67_A30C_00B24D465703__INCLUDED_)
#define AFX_RTFHELP_H__2F656B00_9534_4E67_A30C_00B24D465703__INCLUDED_
// Copyright  2005, Joseph M. Newcomer, All Rights Reserved
// You are free to redistribute FlounderClock providing all copyrights are left intact
// You must record any changes you make to this source by putting // and your
// initials at the end of each line you change. You may not remove any lines
// from this source; instead, put // in front of them and your initials at the end.
// 
// Parts of this module are based on the COleRichEditCtrl by Mike O'Neill
// see http://www.codeproject.com/richedit/COleRichEditCtrl.asp

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RTFHelp.h : header file
//
#include "RichEditCtrlEx.h"
/////////////////////////////////////////////////////////////////////////////
// CRTFHelp window
#include <richole.h>

class CRTFHelp : public CRichEditCtrlEx
{
// Construction
public:
        CRTFHelp();

// Attributes
public:

// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CRTFHelp)
        protected:
        virtual void PreSubclassWindow();
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CRTFHelp();

        // Generated message map functions
protected:
        BOOL CallbackSet;

        interface IExRichEditOleCallback; // forward declaration
        IExRichEditOleCallback * ICallback;

        //*****************************************************************************
        interface IExRichEditOleCallback : public IRichEditOleCallback {
            public:
               IExRichEditOleCallback();
               virtual ~IExRichEditOleCallback();
               int m_iNumStorages;
               IStorage* pStorage;
               DWORD m_dwRef;

               virtual HRESULT STDMETHODCALLTYPE GetNewStorage(LPSTORAGE* lplpstg);
               virtual HRESULT STDMETHODCALLTYPE QueryInterface(REFIID iid, void ** ppvObject);
               virtual ULONG STDMETHODCALLTYPE AddRef();
               virtual ULONG STDMETHODCALLTYPE Release();
               virtual HRESULT STDMETHODCALLTYPE GetInPlaceContext(LPOLEINPLACEFRAME FAR *lplpFrame,
                                                                   LPOLEINPLACEUIWINDOW FAR *lplpDoc,
                                                                   LPOLEINPLACEFRAMEINFO lpFrameInfo);
               virtual HRESULT STDMETHODCALLTYPE ShowContainerUI(BOOL fShow);
               virtual HRESULT STDMETHODCALLTYPE QueryInsertObject(LPCLSID lpclsid, LPSTORAGE lpstg, LONG cp);
               virtual HRESULT STDMETHODCALLTYPE DeleteObject(LPOLEOBJECT lpoleobj);
               virtual HRESULT STDMETHODCALLTYPE QueryAcceptData(LPDATAOBJECT lpdataobj,
                                                                 CLIPFORMAT FAR *lpcfFormat,
                                                                 DWORD reco,
                                                                 BOOL fReally,
                                                                 HGLOBAL hMetaPict);
               virtual HRESULT STDMETHODCALLTYPE ContextSensitiveHelp(BOOL fEnterMode);
               virtual HRESULT STDMETHODCALLTYPE GetClipboardData(CHARRANGE FAR *lpchrg, DWORD reco, LPDATAOBJECT FAR *lplpdataobj);
               virtual HRESULT STDMETHODCALLTYPE GetDragDropEffect(BOOL fDrag, DWORD grfKeyState, LPDWORD pdwEffect);
               virtual HRESULT STDMETHODCALLTYPE GetContextMenu(WORD seltyp,
                                                                LPOLEOBJECT lpoleobj,
                                                                CHARRANGE FAR *lpchrg,
                                                                HMENU FAR *lphmenu);
           };
        //*****************************************************************************


        //{{AFX_MSG(CRTFHelp)
                // NOTE - the ClassWizard will add and remove member functions here.
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RTFHELP_H__2F656B00_9534_4E67_A30C_00B24D465703__INCLUDED_)
