#if !defined(AFX_RICHEDITCTRLEX_H__2156E206_3439_4730_BDE9_837CC6FE5B12__INCLUDED_)
#define AFX_RICHEDITCTRLEX_H__2156E206_3439_4730_BDE9_837CC6FE5B12__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// RicheditCtrlEx.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRicheditCtrlEx window

class CRichEditCtrlEx : public CRichEditCtrl
{
// Construction
public:
        CRichEditCtrlEx();

// Attributes
public:

// Operations
public:
#if _MFC_VER < 0x0700
   int GetTextRange(int start, int end, CString & s);
   __inline BOOL SetOleCallback(LPVOID p) {
      ASSERT(::IsWindow(m_hWnd));
      return ::SendMessage(m_hWnd, EM_SETOLECALLBACK, 0, (LPARAM)p);
   } 
   CString GetSelText() const;
   long GetTextLength() const;
   BOOL SetSelectionCharFormat(CHARFORMAT2 & cf);
   BOOL SetSelectionCharFormat(CHARFORMAT & cf) { return CRichEditCtrl::SetSelectionCharFormat(cf); }

#ifdef RICHEDIT30
   BOOL SetZoom(long num, long den) {
      ASSERT(::IsWindow(m_hWnd)); return (BOOL)::SendMessage(m_hWnd, EM_SETZOOM, (WPARAM)num, (LPARAM)den); }
#endif // RICHEDIT30
#endif // _MFC_VER < 0x0700
    DWORD GetSelectionCharFormat(CHARFORMAT2 & cf);
    void SetWindowTextNoNotify(const CString & s);
    void SetSelNoNotify(long low, long high);
    __inline BOOL AutoURLDetect(BOOL mode) {
                                            ASSERT(::IsWindow(m_hWnd));
                                            return ::SendMessage(m_hWnd, EM_AUTOURLDETECT, (WPARAM)mode, 0); }


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CRichEditCtrlEx)
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CRichEditCtrlEx();

        // Generated message map functions
protected:
        //{{AFX_MSG(CRichEditCtrlEx)
                // NOTE - the ClassWizard will add and remove member functions here.
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_RICHEDITCTRLEX_H__2156E206_3439_4730_BDE9_837CC6FE5B12__INCLUDED_)
