#if !defined(AFX_SCRIPTSTRINGANALYSISPANEL_H__4ECF15BF_C9D9_4DED_994D_C86A53DB9A5D__INCLUDED_)
#define AFX_SCRIPTSTRINGANALYSISPANEL_H__4ECF15BF_C9D9_4DED_994D_C86A53DB9A5D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ScriptStringAnalysisPanel.h : header file
//
#include "WhatIsItButton.h"
#include "WhatIsThisEdit.h"
/////////////////////////////////////////////////////////////////////////////
// CScriptStringAnalysisPanel dialog

class CScriptStringAnalysisPanel : public CDialog
{
    DECLARE_DYNCREATE(CScriptStringAnalysisPanel)
// Construction
public:
        CScriptStringAnalysisPanel(CWnd* pParent = NULL);   // standard constructor
        DWORD GetFlags();
        CString GetFlagString(DWORD flags, const CString & or);
        CString GetWidthString();
// Dialog Data
        //{{AFX_DATA(CScriptStringAnalysisPanel)
        enum { IDD = IDD_SCRIPTSTRINGANALYSE };
        CWhatIsItButton c_UseSpecificWidth;
        CWhatIsItButton c_GetClientRect;
        CButton x_Width;
        CWhatIsThisEdit   c_Width;
        CSpinButtonCtrl c_SpinWidth;
        CWhatIsItButton c_SSA_PASSWORD;
        CWhatIsItButton c_SSA_TAB;
        CWhatIsItButton c_SSA_RTL;
        CWhatIsItButton c_SSA_METAFILE;
        CWhatIsItButton c_SSA_LINK;
        CWhatIsItButton c_SSA_HOTKEYONLY;
        CWhatIsItButton c_SSA_HOTKEY;
        CWhatIsItButton c_SSA_HIDEHOTKEY;
        CWhatIsItButton c_SSA_GLYPHS;
        CWhatIsItButton c_SSA_GCP;
        CWhatIsItButton c_SSA_FIT;
        CWhatIsItButton c_SSA_FALLBACK;
        CWhatIsItButton c_SSA_DZWG;
        CWhatIsItButton c_SSA_CLIP;
        CWhatIsItButton c_SSA_BREAK;
        //}}AFX_DATA


// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CScriptStringAnalysisPanel)
        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
        //}}AFX_VIRTUAL

// Implementation
protected:
        void ReportChange();
        void updateControls();
        // Generated message map functions
        //{{AFX_MSG(CScriptStringAnalysisPanel)
        virtual BOOL OnInitDialog();
        afx_msg void OnSsaBreak();
        afx_msg void OnSsaClip();
        afx_msg void OnSsaDzwg();
        afx_msg void OnSsaFallback();
        afx_msg void OnSsaFit();
        afx_msg void OnSsaGcp();
        afx_msg void OnSsaGlyphs();
        afx_msg void OnSsaHidehotkey();
        afx_msg void OnSsaHotkey();
        afx_msg void OnSsaHotkeyonly();
        afx_msg void OnSsaLink();
        afx_msg void OnSsaMetafile();
        afx_msg void OnSsaPassword();
        afx_msg void OnSsaRtl();
        afx_msg void OnSsaTab();
        afx_msg void OnChangeWidth();
        afx_msg void OnGetclientrect();
        afx_msg void OnUseSpecificWidth();
        //}}AFX_MSG
        DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCRIPTSTRINGANALYSISPANEL_H__4ECF15BF_C9D9_4DED_994D_C86A53DB9A5D__INCLUDED_)
