#pragma once

class UnicodeData {
    public:
       BOOL Load();
       LPCSTR Find(WCHAR ch); // returns pointer to 8-bit data
       class Substring {
           public:
               Substring(LPCSTR p, UINT L) { s = p; length = L; }
               LPCSTR GetPtr() const { return s; }
               UINT GetLength() const { return length; }
               CString GetString() const { return CString(s, length); }
           protected:
              LPCSTR s;
              UINT length;
       };
       Substring GetField(UINT col, LPCSTR p);
       Substring GetNextField(const Substring & ss);
       POSITION GetFirstCode();
       LPCSTR GetNextCode(POSITION & p);
       int GetRange() { return size; }
       int GetPos(POSITION p) { return (int) ((LPCSTR)p - data); }
    protected:
       LPCSTR data;
       DWORD size;
       CArray<LPCSTR, LPCSTR>Index;
};
