#if !defined(AFX_UNICODEDISPLAY_H__1B832068_0B6A_4C6F_A463_B6D8A46290B6__INCLUDED_)
#define AFX_UNICODEDISPLAY_H__1B832068_0B6A_4C6F_A463_B6D8A46290B6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ListCtrlEx.h"
// UnicodeDisplay.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CUnicodeDisplay window

#include "ShowGlyph.h"

class CUnicodeDisplay : public CListCtrlEx
{
// Construction
public:
        CUnicodeDisplay();

// Attributes
public:
        void SetGlyphColumn(int n) { GlyphColumn = n; }
        void ReActivatePopupDisplay();
// Operations
public:

// Overrides
        // ClassWizard generated virtual function overrides
        //{{AFX_VIRTUAL(CUnicodeDisplay)
        virtual void DrawItem(LPDRAWITEMSTRUCT dis);
        //}}AFX_VIRTUAL

// Implementation
public:
        virtual ~CUnicodeDisplay();

        // Generated message map functions
protected:
        void ActivatePopupDisplay(CPoint pt);
        CShowGlyph popup;
        int GlyphColumn;
        BOOL visible;
        void ShowPopup(CPoint point);
        BOOL PreShowPopup(CPoint point);
        void PostShowPopup(CPoint point);
        void HidePopup();
        void HideCharacter();
        void ShowCharacter(CPoint point, const CString & glyph);
        void ShowText(CPoint point, const CString & text);
        int oldtop;

        afx_msg LRESULT OnUpdateNeeded(WPARAM, LPARAM);
        afx_msg LRESULT OnMouseLeave(WPARAM, LPARAM);

        //{{AFX_MSG(CUnicodeDisplay)
        afx_msg void OnMouseMove(UINT nFlags, CPoint point);
        //}}AFX_MSG

        DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_UNICODEDISPLAY_H__1B832068_0B6A_4C6F_A463_B6D8A46290B6__INCLUDED_)
