/****************************************************************************
*                               UWM_SELECT_LCTYPE
* Inputs:
*       WPARAM: unused, 0
*       LPARAM: control ID
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Notifies the parent that the window has gotten the focus
****************************************************************************/

#define UWM_SELECT_LCTYPE_MSG _T("UWM_SELECT_LCTYPE-{1B126586-5F3E-46f7-9E4B-680F2B41B93D}")


/****************************************************************************
*                              UWM_DESELECT_ALL
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sent by a child: Asks the parent to deselect all windows
*       Received by a child: marks itself as unselected. If it was selected
*               forces a redraw
****************************************************************************/

#define UWM_DESELECT_ALL_MSG _T("UWM_DESELECT_ALL-{1B126586-5F3E-46f7-9E4B-680F2B41B93D}")

