#include "msg.h"

/****************************************************************************
*                               UWM_QUERY_SAVE
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       (LRESULT)(BOOL) TRUE if save is possible, FALSE if not recognized
* Effect: 
*       Tells the page it is sent to to save its contents
****************************************************************************/

#define UWM_QUERY_SAVE_MSG _T("UWM_QUERY_SAVE-{B41B8BB5-6933-4958-86F4-8CA9F7541F81}")


/****************************************************************************
*                                  UWM_SAVE
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Tells the target to save whatever it is that it saves
****************************************************************************/

#define UWM_SAVE_MSG _T("UWM_SAVE-{B41B8BB5-6933-4958-86F4-8CA9F7541F81}")


